Attribute VB_Name = "ceSDK"
' --------------------------------------------------------------
'            Copyright (C) 2000-2011 COMIZOA Co., LTD.          
' --------------------------------------------------------------

' DATE  : 2011-05-24
' TIME  : 16:28:22

'******************************************************************************
'* [ ceSDKdef.h ]
'* Header file for definitions of constants and data in ceSDK library
'* - Update Date: 2008/03/26
'* - Provider: COMIZOA Co., Ltd.
'* - Phone: +82-42-936-6500~6
'* - Fax  : +82-42-936-6507
'* - URL  : http://www.comizoa.co.kr,  http://www.comizoa.com
'*******************************************************************************

        '*******************************************************************************
Public Const DESCRIPTION_STRING = "COMIZOA Ethernet/IP Software Development Kit"

        '//////////////////////////////////////////////////////////////////////

        ' General Defines

        '//////////////////////////////////////////////////////////////////////
Public Const CE_TRUE = 1
Public Const CE_FALSE = 0

        '//////////////////////////////////////////////////////////////////////

        ' cnGnResetNode

        '//////////////////////////////////////////////////////////////////////
Public Const CE_RESET_DIO = &H1
Public Const CE_RESET_MOTION = &H2
Public Const CE_RESET_AIO = &H4
Public Const CE_RESET_ALL = CE_RESET_DIO Or CE_RESET_MOTION Or CE_RESET_AIO
Public Const CE_RESET_CFG_RESTORE = &H10000

        '//////////////////////////////////////////////////////////////////////

        ' General Error Codes

        '//////////////////////////////////////////////////////////////////////
Public Const ceERR_NONE = 0
Public Const ceERR_INVALID_PARAMETER = -100
Public Const ceGnERR_TIMEOUT = -101
        ' communication timeout error
Public Const ceGnERR_INVALID_PACKET = -102
        ' Packet data error
Public Const ceGnERR_CHECKSUM = -103
        ' checksum mismatch
Public Const ceGnERR_FLASH_ERASE_FAIL = -104
        ' fali to erase flash-memory
Public Const ceGnERR_UNDEFINE_COMMAND = -105
        ' Undefined control command has been received

        '//////////////////////////////////////////////////////////////////////

        ' Motion API Error Codes

        '//////////////////////////////////////////////////////////////////////
Public Const cemERR_MEM_ALLOC_FAIL = -290
        ' Memory allocation fail
Public Const cemERR_GLOBAL_MEM_FAIL = -292
        ' Global memory allocation fail
Public Const cemERR_ISR_CONNEC_FAIL = -310
        ' ISR registration fail
Public Const cemERR_DIVIDE_BY_ZERO = -400
        ' Cause divide by zero error
Public Const cemERR_WORNG_NUM_DATA = -500
        ' Number of data is too small or too big
Public Const cemERR_VER_MISMATCH = -600
        ' Version(of file or device) mismatch
Public Const cemERR_INVALID_DEVICE_ID = -1010
        ' Invalid device id > Load Device Ǵ SetDeviceId()...
Public Const cemERR_INVALID_HANDLE = -1020
Public Const cemERR_UNSUPORTED_FUNC = -1030
Public Const cemERR_INVALID_PARAMETER = -1101
Public Const cemERR_INVALID_CHANNEL = -1105
Public Const cemERR_INVALID_INPUT_RANGE = -1111
        ' Invalid range value (AI, AO)
Public Const cemERR_INVALID_FREQ_RANGE = -1121
        ' Invalid input or output frequency
Public Const cemERR_FILE_CREATE_FAIL = -1501
        ' File create fail
Public Const cemERR_FILE_OPEN_FAIL = -1511
        ' File open fail
Public Const cemERR_FILE_READ_FAIL = -1522
        ' File reading fail
Public Const cemERR_EVENT_CREATE_FAIL = -1550
        ' Event handle creation fail
Public Const cemERR_INT_INSTANCE_FAIL = -1560
        ' Interrupt event instance creation fail
Public Const cemERR_DITHREAD_CRE = -1570
        ' D/I state change monitor thread creation fail
Public Const cemERR_BUFFER_SMALL = -1580
        ' Buffer size is too small
Public Const cemERR_HIGH_TIMER_UNSUPP = -1590
        ' The installed hardware does not support a high-resolution performance counter (cemmUtlDelayMicroSec() function fails)
Public Const cemERR_OUT_OF_RANGE = -1600
        ' The range of some parameter is out of range
Public Const cemERR_ON_MOTION = -5001
Public Const cemERR_STOP_BY_SLP = -5002
        ' Abnormally stopped by positive soft limit
Public Const cemERR_STOP_BY_SLN = -5003
        ' Abnormally stopped by negative soft limit
Public Const cemERR_STOP_BY_CMP3 = -5004
        ' Abnormally stopped by comparator3
Public Const cemERR_STOP_BY_CMP4 = -5005
        ' Abnormally stopped by comparator4
Public Const cemERR_STOP_BY_CMP5 = -5006
        ' Abnormally stopped by comparator5
Public Const cemERR_STOP_BY_ELP = -5007
        ' Abnormally stopped by (+) external limit
Public Const cemERR_STOP_BY_ELN = -5008
        ' Abnormally stopped by (-) external limit
Public Const cemERR_STOP_BY_ALM = -5009
        ' Abnormally stopped by alarm input signal
Public Const cemERR_STOP_BY_CSTP = -5010
        ' Abnormally stopped by CSTP input signal
Public Const cemERR_STOP_BY_CEMG = -5011
        ' Abnormally stopped by CEMG input signal
Public Const cemERR_STOP_BY_SD = -5012
        ' Abnormally stopped by SD input signal
Public Const cemERR_STOP_BY_DERROR = -5013
        ' Abnormally stopped by operation data error
Public Const cemERR_STOP_BY_IP = -5014
        ' Abnormally stopped by other axis error during interpolation
Public Const cemERR_STOP_BY_PO = -5015
        ' An overflow occurred in the PA/PB input buffer
Public Const cemERR_STOP_BY_AO = -5016
        ' Out of range position counter during interpolation
Public Const cemERR_STOP_BY_EE = -5017
        ' An EA/EB input error occurred (does not stop)
Public Const cemERR_STOP_BY_PE = -5018
        ' An PA/PB input error occurred (does not stop)
Public Const cemERR_STOP_BY_SLVERR = -5019
        ' Abnormally stopped because slave axis has been stopped
Public Const cemERR_STOP_BY_SEMG = -5020
        ' Abnormally stopped by software emergency setting
Public Const cemERR_MOT_MAOMODE = -5110
        ' Master output mode is not CW/CCW mode // Master/Slave ۽ÿ Master output尡 CW/CCW尡 ƴϴ.
Public Const cemERR_MOT_SLAVE_SET = -5120
        ' Slave start fail (Motion state "Wait for Pulsar Input"  ʴ´.
Public Const cemERR_SPEED_RANGE_OVER = -5130
        '
Public Const cemERR_INVALID_SPEED_SET = -5140
        ' Speed setting value is not valid
Public Const cemERR_ACC_LOW_LIMIT_OVER = -5142
        ' Acceleration setting value is too low
Public Const cemERR_ACC_HIGH_LIMIT_OVER = -5143
        ' Acceleration setting value is too high
Public Const cemERR_DEC_LOW_LIMIT_OVER = -5144
        ' Deceleration setting value is too low
Public Const cemERR_DEC_HIGH_LIMIT_OVER = -5145
        ' Deceleration setting value is too high
Public Const cemERR_INVALID_IXMAP = -5150
        ' Invalid interpolation map
Public Const cemERR_INVALID_LMMAP = -5160
        ' Invalid List-Motion Map
Public Const cemERR_MOT_SEQ_SKIPPED = -5170
        ' Motion command is skipped because the axis is already running.

        '//////////////////////////////////////////////////////////////////////

        ' Process Boost Mode & Level

        '//////////////////////////////////////////////////////////////////////

        ' MODE
Public Const CE_PROCESS_ONLY_BOOST = 0
Public Const CE_SERVICE_ONLY_BOOST = 1
Public Const CE_ALL_BOOST = 2

        ' LEVEL
Public Const CE_ABOVE_NORMAL_PRIORITY_CLASS = &H8000
Public Const CE_BELOW_NORMAL_PRIORITY_CLASS = &H4000
Public Const CE_HIGH_PRIORITY_CLASS = &H80
Public Const CE_IDLE_PRIORITY_CLASS = &H40
Public Const CE_NORMAL_PRIORITY_CLASS = &H20
Public Const CE_PROCESS_MODE_BACKGROUND_BEGIN = &H100000
Public Const CE_PROCESS_MODE_BACKGROUND_END = &H200000
Public Const CE_REALTIME_PRIORITY_CLASS = &H100

        '//////////////////////////////////////////////////////////////////////

        ' ceSDK Type Definition

        '//////////////////////////////////////////////////////////////////////

        '//////////////////////////////////////////////////////////////////////

        ' API Argument or Value Definition

        ' Motion I/O Property ID

        ' MIO Property ID
        
Public Const cemALM_LOGIC = 0
Public Const cemALM_MODE = 1
Public Const cemCMP_LOGIC = 2
Public Const cemDR_LOGIC = 3
Public Const cemEL_LOGIC = 4
Public Const cemEL_MODE = 5
Public Const cemERC_LOGIC = 6
Public Const cemERC_OUT = 7
Public Const cemEZ_LOGIC = 8
Public Const cemINP_EN = 9
Public Const cemINP_LOGIC = 10
Public Const cemLTC_LOGIC = 11
Public Const cemLTC_LTC2SRC = 12
Public Const cemORG_LOGIC = 13
Public Const cemSD_EN = 14
Public Const cemSD_LOGIC = 15
Public Const cemSD_LATCH = 16
Public Const cemSD_MODE = 17
Public Const cemSTA_MODE = 18
Public Const cemSTA_TRG = 19
Public Const cemSTP_MODE = 20
Public Const cemCLR_CNTR = 21
Public Const cemCLR_SIGTYPE = 22
Public Const cemCMP_PWIDTH = 23
Public Const cemERC_ONTIME = 24
Public Const cemSVON_LOGIC = 25
        
        
Public Const cemMPID_ALM_LOGIC = 0
Public Const cemMPID_ALM_MODE = 1
Public Const cemMPID_CMP_LOGIC = 2
Public Const cemMPID_DR_LOGIC = 3
Public Const cemMPID_EL_LOGIC = 4
Public Const cemMPID_EL_MODE = 5
Public Const cemMPID_ERC_LOGIC = 6
Public Const cemMPID_ERC_OUT = 7
Public Const cemMPID_EZ_LOGIC = 8
Public Const cemMPID_INP_EN = 9
Public Const cemMPID_INP_LOGIC = 10
Public Const cemMPID_LTC_LOGIC = 11
Public Const cemMPID_LTC_LTC2SRC = 12
Public Const cemMPID_ORG_LOGIC = 13
Public Const cemMPID_SD_EN = 14
Public Const cemMPID_SD_LOGIC = 15
Public Const cemMPID_SD_LATCH = 16
Public Const cemMPID_SD_MODE = 17
Public Const cemMPID_STA_MODE = 18
Public Const cemMPID_STA_TRG = 19
Public Const cemMPID_STP_MODE = 20
Public Const cemMPID_CLR_CNTR = 21
Public Const cemMPID_CLR_SIGTYPE = 22
Public Const cemMPID_CMP_PWIDTH = 23
Public Const cemMPID_ERC_ONTIME = 24
Public Const cemMPID_SVON_LOGIC = 25
Public Const cemMPID_ERC_OUT_EL = 26
Public Const cemMPID_CNT_D_SRC = 27
Public Const cemMPID_CNT_G_SRC = 28
Public Const cemMPID_LTC_TRGMODE = 29

Public Const cemMPID_SLIM_EN = 100
Public Const cemMPID_OUT_MODE = 101
Public Const cemMPID_IN_MODE = 102
Public Const cemMPID_IN_INV = 103
Public Const cemMPID_CEMG_EN = 104
        

        ' Bit order of StReadMioStatuses() return value
        
Public Const cemIOST_RDY = 0
Public Const cemIOST_ALM = 1
Public Const cemIOST_ELN = 2
Public Const cemIOST_ELP = 3
Public Const cemIOST_ORG = 4
Public Const cemIOST_DIR = 5
Public Const cemIOST_EZ = 6
Public Const cemIOST_LTC = 7
Public Const cemIOST_SD = 8
Public Const cemIOST_INP = 9
Public Const cemIOST_DRN = 10
Public Const cemIOST_DRP = 11
Public Const cemIOST_STA = 12
Public Const cemIOST_STP = 13
Public Const cemIOST_ALMR = 14
Public Const cemIOST_EMG = 15
Public Const cemIOST_SVON = 16
Public Const cemIOST_HOMS = 17
Public Const cemIOST_PLSA = 18
        

        ' Motion operation status ID
         
Public Const cemMST_STOP = 0
Public Const cemMST_WAIT_DR = 1
Public Const cemMST_WAIT_STA = 2
Public Const cemMST_WAIT_INSYNC = 3
Public Const cemMST_WAIT_OTHER = 4
Public Const cemMST_WAIT_ERC = 5
Public Const cemMST_WAIT_DIR = 6
Public Const cemMST_RESERVED1 = 7
Public Const cemMST_WAIT_PLSR = 8
Public Const cemMST_IN_RVSSPD = 9
Public Const cemMST_IN_INISPD = 10
Public Const cemMST_IN_ACC = 11
Public Const cemMST_IN_WORKSPD = 12
Public Const cemMST_IN_DEC = 13
Public Const cemMST_WAIT_INP = 14
Public Const cemMST_SPARE0 = 15
Public Const cemMST_HOMMING = 16
        

        ' Signal logic definition
         

Public Const cemLOGIC_A = 0
        'Normal open
Public Const cemLOGIC_B = 1
        'Normal close
        

        ' Axis index definition
         
Public Const cemX1 = 0
Public Const cemY1 = 1
Public Const cemZ1 = 2
Public Const cemU1 = 3
Public Const cemX2 = 4
Public Const cemY2 = 5
Public Const cemZ2 = 6
Public Const cemU2 = 7
        

        ' Definition for axes mask
         

Public Const cemX1_MASK = &H1
Public Const cemY1_MASK = &H2
Public Const cemZ1_MASK = &H4
Public Const cemU1_MASK = &H8

Public Const cemX2_MASK = &H10
Public Const cemY2_MASK = &H20
Public Const cemZ2_MASK = &H40
Public Const cemU2_MASK = &H80
        

        ' Encoder and PA/PB input mode definition
         
Public Const cemIMODE_AB1X = 0
Public Const cemIMODE_AB2X = 1
Public Const cemIMODE_AB4X = 2
Public Const cemIMODE_CWCCW = 3
Public Const cemIMODE_STEP = 4
        

        ' Command output mode definition
         
Public Const cemOMODE_PDIR0 = 0
Public Const cemOMODE_PDIR1 = 1
Public Const cemOMODE_PDIR2 = 2
Public Const cemOMODE_PDIR3 = 3
Public Const cemOMODE_CWCCW0 = 4
Public Const cemOMODE_CWCCW1 = 5
Public Const cemOMODE_CCWCW0 = 6
Public Const cemOMODE_CCWCW1 = 7
        

        ' Control Mode
         
Public Const cemCTRL_OPEN = 0
        ' Open loop control mode
Public Const cemCTRL_SEMI_C = 1
        ' Semi-closed loop control mode (applied only to absolute in-position commands)
Public Const cemCTRL_FULL_C = 2
        ' Full-closed loop control mode (this is not supported at current version)
        

        ' (Linear)Operation direction
        
Public Const cemDIR_N = 0
        '(-)Dir
Public Const cemDIR_P = 1
        '(+)Dir
        

        ' Counter name
         

Public Const cemCNT_COMM = 0
        'Command
Public Const cemCNT_FEED = 1
        'Feedback
Public Const cemCNT_DEV = 2
        'Deviation

Public Const cemCNT_GEN = 3
        'General
Public Const cemCNT_REM = 4
        'Remained
        

        ' Speed mode index definition
         

Public Const cemSMODE_KEEP = -1
        ' Keep previous setting
Public Const cemSMODE_C = 0
        'Constant
Public Const cemSMODE_T = 1
        'Trapeziodal
Public Const cemSMODE_S = 2
        'S-curve
        

        ' Arc operation direction
         
Public Const cemARC_CW = 0
Public Const cemARC_CCW = 1
        

        ' Compare Method
        
Public Const cemDISABLE = 0
Public Const cemEQ_BIDIR = 1
Public Const cemEQ_PDIR = 2
Public Const cemEQ_NDIR = 3
Public Const cemLESS = 4
        'Cnt<Data
Public Const cemGREATER = 5
        'Cnt>Data
        

        ' Action when general comparator met the condition
        
Public Const cemEVNT_ONLY = 0
Public Const cemEVNT_IS = 1
Public Const cemEVNT_DS = 2
Public Const cemEVNT_SPDCHG = 3
        

        ' Backlash/Slip correction mode
        
Public Const cemCORR_DIS = 0
        ' Disable correction
Public Const cemCORR_BACK = 1
        ' Backlash correction mode
Public Const cemCORR_SLIP = 2
        ' Slip correction mode
        

        ' Using for preregister option
        
Public Const cemEXOPT_SET_USE_PREREG = 0
        

        ' Interrupt Handler Type
        

Public Const cemIHT_MESSAGE = 0
Public Const cemIHT_EVENT = 1
Public Const cemIHT_CALLBACK = 2
        

        ' Interrupt Handler Type
        
Public Const cemSTR_AXIS_NAME = 0
Public Const cemSTR_DIST_UNIT = 1
Public Const cemSTR_SPEED_UNIT = 2
        

        ' Sequence Mode
        
Public Const cemSEQM_SKIP_RUN = 0
Public Const cemSEQM_WAIT_RUN = 1
        

        ' Map Type
        
Public Const cemDMAP_MOTION = 0
Public Const cemDMAP_DIO = 1
Public Const cemDMAP_ALL = 2
        

        ' SetFilterAB 
        
Public Const cemAB_ENC = 0
Public Const cemAB_PULSAR = 1
        

        ' Axis Capability ID
        

Public Const cemCAPX_CMD_DIR = 0
        ' Command direction change function
Public Const cemCAPX_EL_MAN_SET = 1
        ' -/+EL Manual control function
Public Const cemCAPX_CMP_HIGH = 2
        ' High-speed Compare Output function
        

        ' Axis Return to home clear mode
        

Public Const cemHPCM_DISABLE = -1
        ' Disable HomePosClearMode
Public Const cemHPCM_M0 = 0
        ' ORG(/EL/EZ) ȣ ߻  COMMAND & FEEDBACK ġ 0 ŬѴ.
Public Const cemHPCM_M1 = 1
        ' ͸  Ϸϰ  COMMAND & FEEDBACK ġ  0 ŬѴ.
Public Const cemHPCM_M2 = 2
        ' ͸  Ϸϰ  FEEDBACK ġ ״ ΰ COMMAND ġ FEEDBACK ġ ġŲ.
        
        
Public Const cemLTM_LTC = 0
        ' LTC Է ȣ ؼ  ġ ˴ϴ.
Public Const cemLTM_ORG = 1
        ' ORG Է ȣ ؼ  ġ ˴ϴ.
        

        ' Sync mode
        
Public Const cemSYNC_DISABLE = 0
Public Const cemSYNC_INT_SYNC = 1
Public Const cemSYNC_OTHER_STOP = 2
        

        ' Internal sync. conditions
        
Public Const cemISYNC_ACC_STA = 0
        ' 0: at start of acceleration
Public Const cemISYNC_ACC_END = 1
        ' 1: at end of acceleration
Public Const cemISYNC_DEC_STA = 2
        ' 2: at start of deceleration
Public Const cemISYNC_DEC_END = 3
        ' 3: at end of deceleration
Public Const cemISYNC_SLN = 4
        ' 4: when (-)software limit met
Public Const cemISYNC_SLP = 5
        ' 5: when (+)software limit met
Public Const cemISYNC_GCMP = 6
        ' 6: when General Comparator condition is satisfied
Public Const cemISYNC_TCMP = 7
        ' 7: when Trigger Comparator condition is satisfied
        

        ' DIO Mode
        
Public Const cemDIOMODE_IN = 0
        'Input Mode
Public Const cemDIOMODE_OUT = 1
        'Output Mode
        

        '//////////////////////////////////////////////////////////////////////

        ' Basic Node Information

        '//////////////////////////////////////////////////////////////////////
Public Const MAX_NODE = 255
Public Const MAX_MOT_MODULE = 10
Public Const MAX_DIO_MODULE = 10
Public Const MAX_AI_MODULE = 10
Public Const MAX_AO_MODULE = 10
Public Const MAX_MDIO_MODULE = 10
Public Const MAX_CNT_MODULE = 10

        '//////////////////////////////////////////////////////////////////////

        ' Sub Module Type Information

        '//////////////////////////////////////////////////////////////////////
Public Const MODULE_DI32_ONLY_TYPE = &H0
        ' DI 32ch
Public Const MODULE_DO32_ONLY_TYPE = &H1
        ' DO 32ch
Public Const MODULE_MOT_TYPE = &H2
Public Const MODULE_AI_TYPE = &H3
Public Const MODULE_AO_TYPE = &H4
Public Const MODULE_DIO_TYPE = &H5
        ' DIO bidirectional 16ch
Public Const MODULE_CNT_TYPE = &H6
Public Const MODULE_SER_TYPE = &H7
Public Const MODULE_MDIO_TYPE = &H8

        '//////////////////////////////////////////////////////////////////////

        ' Configuration I/O [cnBuilder]

        '//////////////////////////////////////////////////////////////////////

        '//////////////////////////////////////////////////////////////////////

        ' ȯ漳   

        '  1. [TCneHeader] ü 

        '  2. [TCneAxis] x [TCneHeader::nNumAxis] 

        '  3. [TCneDio32] x [TCneHeader::nNumDioChan/32+1] .

        ' Configuration structure for a motion axis

        '///////////////////////////////////////////////////////////////////////////

        ' Configuration structure for 32 DIO channels

        ' : ⼭ ä ȣ Input/Output   äιȣ ǹѴ.

        ' Header for configuration for a node
Public Const MAX_AXES_COUNT = 10
Public Const MAX_DIO_COUNT = 10

        ' ceSDK Log Level

        '

        ' No logging at all                                    : LL_NONE            0

        ' Log server startup/shutdown                          : LL_STATE           0

        ' Log connect/disconnect                               : LL_CLIENTS     1

        ' Log connection errors (wrong pixfmt, etc)            : LL_CONNERR     0

        ' Log socket errors                                    : LL_SOCKERR     4

        ' Log internal errors                                  : LL_INTERR          0

        ' Log internal warnings                                : LL_INTWARN    8

        ' Log internal info                                                         : LL_INTINFO        9

        ' Log socket errors                                    : LL_SOCKINFO    10

        ' Log everything, including internal table setup, etc. : LL_ALL         10
Public Const LL_NONE = 0
Public Const LL_STATE = 9
Public Const LL_CLIENTS = 1
Public Const LL_CONNERR = 0
Public Const LL_SOCKERR = 4
Public Const LL_INTERR = 0
Public Const LL_INTWARN = 8
Public Const LL_INTINFO = 9
Public Const LL_SOCKINFO = 10
Public Const LL_GENERAL = 4
Public Const LL_MOTION = 5
Public Const LL_DIO = 6
Public Const LL_AIO = 6
Public Const LL_CNT = 6
Public Const LL_SERIAL = 7
Public Const LL_INTLOCK = 8
Public Const LL_UTIL = 8
Public Const LL_ALL = 10
'******************************************************************************
'* [ ceSDK.h ]
'* Header file for definitions of constants and data in ceSDK library
'* - Update Date: 2008/03/26
'* - Provider: COMIZOA Co., Ltd.
'* - Phone: +82-42-936-6500~6
'* - Fax  : +82-42-936-6507
'* - URL  : http://www.comizoa.co.kr,  http://www.comizoa.com
'*******************************************************************************
'*******************************************************************************
'
'****************************************************************************
'*************** START OF Load/Unload DLL FUNCTION DECLARATIONS *************
'****************************************************************************
' ceSDK ̺귯 ε.
' ceSDK ̺귯 ε.
'****************************************************************************
'*************** START OF GENERAL FUNCTION DECLARATIONS *********************
'****************************************************************************
' ̺귯 ε ¿ ġ ε.
Public Declare Function ceGnLoad _
Lib "ceSDKDLL.dll" _
() _
As Long

' ̺귯 ε ¿ ġ ε.
Public Declare Function ceGnUnload _
Lib "ceSDKDLL.dll" _
() _
As Long

'   
' [LogLevel : (ceSDKDef.h)  մϴ]
Public Declare Function ceGnLogLevel_Set _
Lib "ceSDKDLL.dll" _
(ByVal LogLevel As Long) _
As Long

'   ȯ
' [LogLevel : (ceSDKDef.h)  մϴ]
Public Declare Function ceGnLogLevel_Get _
Lib "ceSDKDLL.dll" _
(ByRef LogLevel As Long) _
As Long

'    մϴ.
' [LogMode : 0: Disable , 1: OutputDebugString, 2 : FILE, 4: Console, szLogDir : α  ϵ ]
Public Declare Function ceGnLogMode_Set _
Lib "ceSDKDLL.dll" _
(ByVal LogMode As Long, ByRef szLogDir As String) _
As Long

'   ȯ մϴ.
' [LogMode : 0: Disable , 1: OutputDebugString, 2 : FILE, 4: Console]
Public Declare Function ceGnLogMode_Get _
Lib "ceSDKDLL.dll" _
(ByRef LogMode As Long) _
As Long

' ̺귯 ε ¿ 带 ٽ Žմϴ.
' [RealNode:   , nTimeout: Ÿ ƿ, IsBlocking: Ϸɶ ޼  , pResultNode: ε   ȯ]
Public Declare Function ceGnReSearchDevice _
Lib "ceSDKDLL.dll" _
(ByVal RealNode As Long, ByVal nTimeout As Long, ByVal IsBlocking As Long, ByRef pResultNode As Long) _
As Long

'  Ž ϷǾ ִ Ȯմϴ.  μ ٸ μ ̹ 尡 ŽǾٸ,  Լ 
' ̹ Ž 带   Ž ϰų  ʵ   ֽϴ.
' [IsSearchedDevice: ̹  Ž Ǿ ִ  TRUE  ȯϸ, Ž Ǿ    FALSE  ȯմϴ]
Public Declare Function ceGnIsSearchedDevice _
Lib "ceSDKDLL.dll" _
(ByRef IsSearchedDevice As Long) _
As Long

' ġ ε ¿ ġ ȯ  ȯ.
' [RealNode:   , nTimeout: Ÿ ƿ, IsBlocking: Ϸɶ ޼  , pResultNode: ü   ȯ]
Public Declare Function ceGnSearchDevice _
Lib "ceSDKDLL.dll" _
(ByVal RealNode As Long, ByVal nTimeout As Long, ByVal IsBlocking As Long, ByRef pResultNode As Long) _
As Long

'  Ž ʱȭ ϸ,  Լ   ceGnSearchDevice    Ž   ֽϴ.
Public Declare Function ceGnUnSearchDevice _
Lib "ceSDKDLL.dll" _
() _
As Long

' ε ü   ȯ.
' [Node : ε   ȯ]
Public Declare Function ceGnTotalNode _
Lib "ceSDKDLL.dll" _
(ByRef Node As Long) _
As Long

' ε     ȯ.
' [Channel : ε     ȯ]
Public Declare Function ceGnTotalMotionChannel _
Lib "ceSDKDLL.dll" _
(ByRef Channel As Long) _
As Long

' ε   ä  ȯ.
' [Channel : ε   ä  ȯ]
Public Declare Function ceGnTotalDIOChannel _
Lib "ceSDKDLL.dll" _
(ByRef Channel As Long) _
As Long

' ε Ƴα Է ä  ȯ.
' [Channel : ε Ƴα Է ä  ȯ]
Public Declare Function ceGnTotalAIChannel _
Lib "ceSDKDLL.dll" _
(ByRef Channel As Long) _
As Long

' ε Ƴα  ä  ȯ.
' [Channel : ε Ƴα  ä  ȯ]
Public Declare Function ceGnTotalAOChannel _
Lib "ceSDKDLL.dll" _
(ByRef Channel As Long) _
As Long

' ε    ä  ȯ.
' [Channel : ε    ä  ȯ]
Public Declare Function ceGnTotalMDIOChannel _
Lib "ceSDKDLL.dll" _
(ByRef Channel As Long) _
As Long

' ε ī ä  ȯ.
' [Channel : ε ī ä  ȯ]
Public Declare Function ceGnTotalCNTChannel _
Lib "ceSDKDLL.dll" _
(ByRef Channel As Long) _
As Long

' ش      ȯ.
' [NodeID :  ȣ, ModuleCount : ش      ȯ]
Public Declare Function ceGnModuleCount_Motion _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef ModuleCount As Long) _
As Long

' ش      ȯ.
' [NodeID :  ȣ, ModuleCount : ش      ȯ]
Public Declare Function ceGnModuleCount_Dio _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef ModuleCount As Long) _
As Long

' ش  Ƴα Է   ȯ.
' [NodeID :  ȣ, ModuleCount : ش  Ƴα Է   ȯ]
Public Declare Function ceGnModuleCount_Ai _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef ModuleCount As Long) _
As Long

' ش  Ƴα    ȯ.
' [NodeID :  ȣ, ModuleCount : ش  Ƴα    ȯ]
Public Declare Function ceGnModuleCount_Ao _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef ModuleCount As Long) _
As Long

' ش       ȯ.
' [NodeID :  ȣ, ModuleCount : ش     ä   ȯ]
Public Declare Function ceGnModuleCount_Mdio _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef ModuleCount As Long) _
As Long

' ش  ī   ȯ.
' [NodeID :  ȣ, ModuleCount : ش  ī   ȯ]
Public Declare Function ceGnModuleCount_Cnt _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef ModuleCount As Long) _
As Long

' ش   ⿡      ȯ.
' [NodeID :  ȣ, ModuleIdx :   ȣ, ChannelCount :     ȯ]
Public Declare Function ceGnChannelCount_Motion _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleIdx As Long, ByRef ChannelCount As Long) _
As Long

' ش    ⿡  ä  ȯ .
' [NodeID :  ȣ, ModuleIdx :    ȣ, ChannelCount :   ä  ȯ]
Public Declare Function ceGnChannelCount_Dio _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleIdx As Long, ByRef ChannelCount As Long) _
As Long

' ش  Ƴα Է ⿡  ä  ȯ.
' [NodeID :  ȣ, ModuleIdx : Ƴα Է  ȣ, ChannelCount : Ƴα Է ä  ȯ]
Public Declare Function ceGnChannelCount_Ai _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleIdx As Long, ByRef ChannelCount As Long) _
As Long

' ش  Ƴα  ⿡  ä  ȯ.
' [NodeID :  ȣ, ModuleIdx : Ƴα   ȣ, ChannelCount : Ƴα  ä  ȯ]
Public Declare Function ceGnChannelCount_Ao _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleIdx As Long, ByRef ChannelCount As Long) _
As Long

' ش     ⿡  ä  ȯ.
' [NodeID :  ȣ, ModuleIdx :     ȣ, ChannelCount :    ä  ȯ
Public Declare Function ceGnChannelCount_Mdio _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleIdx As Long, ByRef ChannelCount As Long) _
As Long

' ش  ī ⿡  ä  ȯ.
' [NodeID :  ȣ, ModuleIdx : ī  ȣ, ChannelCount : ī ä  ȯ
Public Declare Function ceGnChannelCount_Cnt _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleIdx As Long, ByRef ChannelCount As Long) _
As Long

' ش 忡 Ʈ  Emergency Ȳ ϰų  մϴ.
' [NodeID :  ȣ, State : Emergency ¿ ؼ մϴ]
Public Declare Function ceGnEmergency_Set _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal State As Long) _
As Long

' ش  Ʈ  Emergency Ȳ  ȯմϴ.
' [NodeID :  ȣ, State : Emergency ¿ ؼ ȯմϴ]
Public Declare Function ceGnEmergency_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef State As Long) _
As Long

' ش   ʱȭ.
' [NodeID :  ȣ, ResetMode : ʱȭ ]
Public Declare Function ceGnResetNode _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ResetMode As Long) _
As Long

' ش μ  μ μ 켱 
' [BoostLevel : 켱 , BoostMode : ]
Public Declare Function ceGnCtrlBoost_Set _
Lib "ceSDKDLL.dll" _
(ByVal BoostLevel As Long, ByVal BoostMode As Long) _
As Long

' ش μ  μ μ 켱 ȯ
' [BoostLevel : 켱 , BoostMode : ]
Public Declare Function ceGnCtrlBoost_Get _
Lib "ceSDKDLL.dll" _
(ByRef BoostLevel As Long, ByRef BoostMode As Long) _
As Long

' ش 尡 Ǿ ִ Ǿ ִ Ȯϴ Լ
' [NodeID :  , IsActive :  Ȥ  ]
Public Declare Function ceGnNodeIsActive _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef IsActive As Long) _
As Long

' ش  Flash Memory ȯ    .
' [NodeID :  ȣ]
Public Declare Function ceGnBeginSerialize _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long) _
As Long

' ش 忡 Flash Memory ȯ    .
' [NodeID :  ȣ]
Public Declare Function ceGnEndSerialize _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long) _
As Long

' ش   ࿡      ȯ.
' [Axis :     ȣ, NodeIP :  IP ּ ȯ, NodeID :  ȣ ȯ, NodeInGlobal : ش      ȣ ȯ,
' ModuleIdx : ش   ȣ ȯ, ModuleInCh :      ȣ ȯ]
Public Declare Function ceGnLocalAxis_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef NodeIP As Long, ByRef NodeID As Long, ByRef NodeInGlobal As Long, ByRef ModuleIdx As Long, ByRef ModuleInCh As Long) _
As Long

' ش  I/O äο      ȯ.
' [Channel :    ä ȣ, NodeIP :  IP ּ ȯ, NodeID :  ȣ ȯ, NodeInGlobal : ش     ä ȣ ȯ, ModuleIdx : ش   ȣ ȯ, ModuleInCh :     ä ȣ ȯ]
Public Declare Function ceGnLocalDIO_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef NodeIP As Long, ByRef NodeID As Long, ByRef NodeInGlobal As Long, ByRef ModuleIdx As Long, ByRef ModuleInCh As Long) _
As Long

' ش Ƴα Է äο      ȯ.
' [Channel:  Ƴα Է ä ȣ, NodeIP :  IP ּ ȯ, NodeID :  ȣ ȯ, NodeInGlobal : ش   Ƴα Է ä ȣ ȯ, ModuleIdx : ش   ȣ ȯ, ModuleInCh :   Ƴα Է ä ȣ ȯ]
Public Declare Function ceGnLocalAI_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef NodeIP As Long, ByRef NodeID As Long, ByRef NodeInGlobal As Long, ByRef ModuleIdx As Long, ByRef ModuleInCh As Long) _
As Long

' ش Ƴα  äο      ȯ.
' [Channel:  Ƴα  ä ȣ, NodeIP :  IP ּ ȯ, NodeID :  ȣ ȯ, NodeInGlobal : ش   Ƴα  ä ȣ ȯ, ModuleIdx : ش   ȣ ȯ, ModuleInCh :   Ƴα  ä ȣ ȯ]
Public Declare Function ceGnLocalAO_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef NodeIP As Long, ByRef NodeID As Long, ByRef NodeInGlobal As Long, ByRef ModuleIdx As Long, ByRef ModuleInCh As Long) _
As Long

' ش    äο      ȯ.
' [Channel:  ī ä ȣ, NodeIP :  IP ּ ȯ, NodeID :  ȣ ȯ, NodeInGlobal : ش      ä ȣ ȯ, ModuleIdx : ش   ȣ ȯ, ModuleInCh :       ä ȣ ȯ]
Public Declare Function ceGnLocalMDIO_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef NodeIP As Long, ByRef NodeID As Long, ByRef NodeInGlobal As Long, ByRef ModuleIdx As Long, ByRef ModuleInCh As Long) _
As Long

' ش ī äο      ȯ.
' [Channel:  ī ä ȣ, NodeIP :  IP ּ ȯ, NodeID :  ȣ ȯ, NodeInGlobal : ش   ī ä ȣ ȯ, ModuleIdx : ش   ȣ ȯ, ModuleInCh :   ī  ä ȣ ȯ]
Public Declare Function ceGnLocalCNT_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef NodeIP As Long, ByRef NodeID As Long, ByRef NodeInGlobal As Long, ByRef ModuleIdx As Long, ByRef ModuleInCh As Long) _
As Long

' ش      ȣ Ͽ   ȣ ȯ.
' [NodeID :  ȣ, ModuleIdx : ش   ȣ, ModuleInCh :      ȣ, GlobalAxis :     ȣ ȯ]
Public Declare Function ceGnGlobalAxis_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleIdx As Long, ByVal ModuleInCh As Long, ByRef GlobalAxis As Long) _
As Long

' ش      ä ȣ Ͽ  ä ȣ ȯ.
' [NodeID :  ȣ, ModuleIdx : ش   ȣ, ModuleInCh :     ä ȣ, GlobalDIO :    ä ȣ ȯ]
Public Declare Function ceGnGlobalDIO_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleIdx As Long, ByVal ModuleInCh As Long, ByRef GlobalDIO As Long) _
As Long

' ش  Ƴα Է   ä ȣ Ͽ  ä ȣ ȯ.
' [NodeID :  ȣ, ModuleIdx : ش   ȣ, ModuleInCh :   Ƴα Է ä ȣ, GlobalAI :  Ƴα Է ä ȣ ȯ]
Public Declare Function ceGnGlobalAI_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleIdx As Long, ByVal ModuleInCh As Long, ByRef GlobalAI As Long) _
As Long

' ش  Ƴα    ä ȣ Ͽ  ä ȣ ȯ.
' [NodeID :  ȣ, ModuleIdx : ش   ȣ, ModuleInCh :   Ƴα  ä ȣ, GlobalAO :  Ƴα  ä ȣ ȯ]
Public Declare Function ceGnGlobalAO_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleIdx As Long, ByVal ModuleInCh As Long, ByRef GlobalAO As Long) _
As Long

' ش        ä ȣ Ͽ  ä ȣ ȯ.
' [NodeID :  ȣ, ModuleIdx : ش   ȣ, ModuleInCh :       ä ȣ, GlobalAO :      ä ȣ ȯ]
Public Declare Function ceGnGlobalMDIO_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleIdx As Long, ByVal ModuleInCh As Long, ByRef GlobalMDIO As Long) _
As Long

' ش  ī   ä ȣ Ͽ  ä ȣ ȯ.
' [NodeID :  ȣ, ModuleIdx : ش   ȣ, ModuleInCh :   ī ä ȣ, GlobalAO :  ī ä ȣ ȯ]
Public Declare Function ceGnGlobalCNT_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleIdx As Long, ByVal ModuleInCh As Long, ByRef GlobalCNT As Long) _
As Long

'****************************************************************************
'*************** START OF GENERAL MOTION FUNCTION DECLARATIONS **************
'****************************************************************************
' SERVO-ON ȣ  ΰ Ȥ .
' [Channel :   ȣ, Enable : SERVO-ON ȣ  ON/OFF]
Public Declare Function cemGnServoOn_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal Enable As Long) _
As Long

' SERVO-ON ȣ  ¸ ȯ.
' [Channel:   ȣ, Enable: SERVO-ON ȣ  ¸ ȯ]
Public Declare Function cemGnServoOn_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef Enable As Long) _
As Long

' ش   ˶  ȣ  .
' [Axis :     ȣ, IsReset: ˶  ȣ  ]
Public Declare Function cemGnAlarmReset _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal IsReset As Long) _
As Long

'****************************************************************************
'*************** START OF CONFIGURATION FUNCTION DECLARATIONS ***************
'****************************************************************************
'   ȣ ȯ  . PropId ceSDKDef.h Ͽ ǵ enum _TCmMioPropId  Ʈ .
' [Axis :   ȣ, PropId : ȯ  Ű , PropVal : PropId  ȯ濡  ]
Public Declare Function cemCfgMioProperty_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal PropId As Long, ByVal PropVal As Long) _
As Long

'   ȣ ȯ   ȯ. PropId ceSDKDef.h Ͽ ǵ enum _TCmMioPropId  Ʈ .
' [Axis :   ȣ, PropId : ȯ  Ű , PropVal : PropId  ȯ濡  ȯ]
Public Declare Function cemCfgMioProperty_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal PropId As Long, ByRef PropVal As Long) _
As Long

'  I/O(Input/Output) ȣ      .
' [Axis :   ȣ, IsEnable :    ]
Public Declare Function cemCfgFilter_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal IsEnable As Long) _
As Long

'  I/O(Input/Output) ȣ       ¸ ȯ.
' [Axis :   ȣ, IsEnabled :     ȯ]
Public Declare Function cemCfgFilter_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef IsEnabled As Long) _
As Long

' EA/EB Ǵ PA/PB ȣ Է ȸο  ͸   .
' [Channel :   ȣ, Target : Լ  (EA/EB or PA/PB), IsEnable :    ]
Public Declare Function cemCfgFilterAB_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal Target As Long, ByVal IsEnable As Long) _
As Long

' EA/EB Ǵ PA/PB ȣ Է ȸο  ͸     ¸ ȯ
' [Channel :   ȣ, Target : Լ  (EA/EB or PA/PB), IsEnabled :     ȯ]
Public Declare Function cemCfgFilterAB_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal Target As Long, ByRef IsEnabled As Long) _
As Long

' ڴ ޽(Feedback Pulse) ȣ Է  .
' [Axis :   ȣ, InputMode : Feedback Pulse Է , IsReverse : Feedback Count  UP/DOWN  ݴ   ]
Public Declare Function cemCfgInMode_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal InputMode As Long, ByVal IsReverse As Long) _
As Long

' ڴ ޽(Feedback Pulse) ȣ Է   ¸ ȯ.
' [Axis :   ȣ, InputMode: Feedback Pulse Է , IsReverse : Feedback Count  UP/DOWN  ݴ    ȯ]
Public Declare Function cemCfgInMode_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef InputMode As Long, ByRef IsReverse As Long) _
As Long

'  ޽(Command Pulse) ȣ   .
' [Axis :   ȣ, OutputMode : Command Pulse  ]
Public Declare Function cemCfgOutMode_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal OutputMode As Long) _
As Long

'  ޽(Command Pulse) ȣ    ¸ ȯ.
' [Axis :   ȣ, OutputMode: Command ޽   ȯ]
Public Declare Function cemCfgOutMode_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef OutputMode As Long) _
As Long

' ̼ ǥ ǥ  Ŀǵ ġ  ǵ ġ  .
' [Axis :   ȣ, CtrlMode :  ]
Public Declare Function cemCfgCtrlMode_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal CtrlMode As Long) _
As Long

' ̼ ǥ ǥ  Ŀǵ ġ  ǵ ġ    ¸ ȯ.
' [Axis :   ȣ, CtrlMode :  ]
Public Declare Function cemCfgCtrlMode_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef CtrlMode As Long) _
As Long

' Է ޽(Feedback Pulse)  ޽(Command Pulse) ش .
' [Axis :   ȣ, Ratio : Feedback Pulse Command Pulse ش ]
Public Declare Function cemCfgInOutRatio_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Ratio As Double) _
As Long

' Է ޽(Feedback Pulse)  ޽(Command Pulse) ش  ¸ ȯ.
' [Axis :   ȣ, Ratio : Feedback Pulse Command Pulse ش  ȯ]
Public Declare Function cemCfgInOutRatio_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef Ratio As Double) _
As Long

'  Ÿ  .
' [Axis :   ȣ, UnitDist :  Ÿ 1 ̵ϱ   ޽ ]
Public Declare Function cemCfgUnitDist_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal UnitDist As Double) _
As Long

'  Ÿ  ȯ.
' [Axis :   ȣ, UnitDist :  Ÿ 1 ̵ϱ   ޽  ȯ]
Public Declare Function cemCfgUnitDist_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef UnitDist As Double) _
As Long

'  ӵ  .
' [Axis :   ȣ, UnitSpeed :  ӵ  ޽  ӵ(PPS)]
Public Declare Function cemCfgUnitSpeed_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal UnitSpeed As Double) _
As Long

'  ӵ  ȯ.
' [Axis :   ȣ, UnitSpeed :  ӵ  ޽  ӵ(PPS) ȯ]
Public Declare Function cemCfgUnitSpeed_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef UnitSpeed As Double) _
As Long

'  ӵ ѹ .
' [Axis :   ȣ, MaxPPS :  ְ ӵ(PPS)]
Public Declare Function cemCfgSpeedRange_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal MaxPPS As Double) _
As Long

'  ӵ ѹ  ¸ ȯ.
' [Axis :   ȣ, MinPPS :   ӵ(PPS) ȯ, MaxPPS :  ְ ӵ(PPS) ȯ]
Public Declare Function cemCfgSpeedRange_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef MinPPS As Double, ByRef MaxPPS As Double) _
As Long

'  ̼  ӵ .
' [Axis :   ȣ, SpeedMode : ӵ , WorkSpeed : ۾ ӵ, Accel : ӵ, Decel : ӵ]
Public Declare Function cemCfgSpeedPattern_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal SpeedMode As Long, ByVal WorkSpeed As Double, ByVal Accel As Double, ByVal Decel As Double) _
As Long

'  ̼  ӵ  ¸ ȯ.
' [Axis :   ȣ, SpeedMode : ӵ  ȯ, WorkSpeed : ۾ ӵ ȯ, Accel : ӵ ȯ, Decel : ӵ ȯ]
Public Declare Function cemCfgSpeedPattern_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef SpeedMode As Long, ByRef WorkSpeed As Double, ByRef Accel As Double, ByRef Decel As Double) _
As Long

' Է ޽(Feedback Pulse)   ӵ  .
' [Axis :   ȣ, IsEnable : Feedback ӵ Ȯ  Ȱ , Interval : Feedback ޽  Ȯ ֱ(ms)]
Public Declare Function cemCfgActSpdCheck_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal IsEnable As Long, ByVal Interval As Long) _
As Long

' Է ޽(Feedback Pulse)   ӵ   ¸ ȯ.
' [Axis :   ȣ, IsEnable : Feedback ӵ Ȯ  Ȱθ ȯ, Interval : Feedback ޽  Ȯ ֱ(ms) ȯ]
Public Declare Function cemCfgActSpdCheck_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef IsEnable As Long, ByRef Interval As Long) _
As Long

'  ̼  Ʈ ̼ѹ Ͽ .
' [Axis :   ȣ, IsEnable : Ʈ   Ȱ , LimitN : (-) Limit, LimitP : (+) Limit]
Public Declare Function cemCfgSoftLimit_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal IsEnable As Long, ByVal LimitN As Double, ByVal LimitP As Double) _
As Long

'  Ʈ ̼ѹ   ȯ.
' [Axis :   ȣ, IsEnable : Ʈ   Ȱ  ȯ, LimitN : (-) Limit ȯ, LimitP : (+) Limit ȯ]
Public Declare Function cemCfgSoftLimit_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef IsEnable As Long, ByRef LimitN As Double, ByRef LimitP As Double) _
As Long

' ī(Ring-Counter)  .
' [Channel :   ȣ, TargCntr : Լ  (Command or Feedback Counter), IsEnable : Ring-Counter  Ȱ , CntMax: ī ]
Public Declare Function cemCfgRingCntr_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal TargCntr As Long, ByVal IsEnable As Long, ByVal CntMax As Double) _
As Long

' ī(Ring-Counter)   ¸ ȯ.
' [Channel:   ȣ, TargCntr: Լ  (Command or Feedback Counter) , IsEnable: Ring-Counter  Ȱ  ȯ, CntMax: ī  ȯ]
Public Declare Function cemCfgRingCntr_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal TargCntr As Long, ByRef IsEnable As Long, ByRef CntMax As Double) _
As Long

' ۾ӵ    ۾ӵ ϴ   .
' [Axis:   ȣ, fCorrRatio: ӵ  (%)]
Public Declare Function cemCfgVelCorrRatio_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal fCorrRatio As Double) _
As Long

' ۾ӵ    ۾ӵ ϴ   ȯ.
' [Axis:   ȣ, fCorrRatio: ӵ  (%) ȯ]
Public Declare Function cemCfgVelCorrRatio_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef fCorrRatio As Double) _
As Long

'  ̼ ۾ Ϸ  ࿡ ο ̼  ϴ޵Ǿ  ó å .
' [seqMode: (Sequence) ]
Public Declare Function cemCfgSeqMode_Set _
Lib "ceSDKDLL.dll" _
(ByVal SeqMode As Long) _
As Long

'  ̼ ۾ Ϸ  ࿡ ο ̼  ϴ޵Ǿ  ó å   ȯ.
' [seqMode: (Sequence)  ȯ]
Public Declare Function cemCfgSeqMode_Get _
Lib "ceSDKDLL.dll" _
(ByRef SeqMode As Long) _
As Long

'****************************************************************************
'*************** START OF HOME RETURN FUNCTION DECLARATIONS *****************
'****************************************************************************
'  ȯ .
' [Axis:   ȣ, HomeMode:  (0~12), Dir:     EzCount: EzCount (0~15), EscDist: Ż Ÿ, Offset:   ġ  ߰  ̵(ǥ ̼)]
Public Declare Function cemHomeConfig_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal HomeMode As Long, ByVal Dir As Long, ByVal EzCount As Long, ByVal EscDist As Double, ByVal Offset As Double) _
As Long

'  ȯ  ¸ ȯ.
' [Axis:   ȣ, HomeMode:  (0~12) ȯ, Dir:     ȯ, EzCount: EzCount (0~15) ȯ, EscDist: Ż Ÿ ȯ, Offset:   ġ  ߰  ̵ ȯ]
Public Declare Function cemHomeConfig_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef HomeMode As Long, ByRef Dir As Long, ByRef EzCount As Long, ByRef EscDist As Double, ByRef Offset As Double) _
As Long

'  Ϸ  ߻ϴ  Ʈѷ  ̺갣    ߻ Է ޽(Feedback Pulse) ó  .
' [Axis:   ȣ, PosClrMode: Command  Feedback ġ ŬǴ ]
Public Declare Function cemHomePosClrMode_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal PosClrMode As Long) _
As Long

'  Ϸ  ߻ϴ  Ʈѷ  ̺갣    ߻ Է ޽(Feedback Pulse) ó   ¸ ȯ.
'[Axis:   ȣ, PosClrMode: Command  Feedback ġ Ŭ Ǵ  ȯ]
Public Declare Function cemHomePosClrMode_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef PosClrMode As Long) _
As Long

'   ӵ .
' [Axis:   ȣ, SpeedMode:  ӵ , Vel:  ۾ ӵ, Accel:  ӵ, Decel:  ӵ, RevVel: Revers Speed]
Public Declare Function cemHomeSpeedPattern_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal SpeedMode As Long, ByVal Vel As Double, ByVal Accel As Double, ByVal Decel As Double, ByVal RevVel As Double) _
As Long

'   ӵ  ¸ ȯ.
' [Axis:   ȣ, SpeedMode:  ӵ  ȯ, Vel:  ۾ ӵ ȯ, Accel: ӵ ȯ, Decel: ӵ ȯ, RevVel: Revers Speed ȯ]
Public Declare Function cemHomeSpeedPattern_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef SpeedMode As Long, ByRef Vel As Double, ByRef Accel As Double, ByRef Decel As Double, ByRef RevVel As Double) _
As Long

'    ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [Axis:   ȣ, IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemHomeMove _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal IsBlocking As Long) _
As Long

'    ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [Axis:   ȣ]
Public Declare Function cemHomeMoveStart _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long) _
As Long

'    ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [NumAxes: ۾   , AxisList:   迭 ּ, IsBlocking: Ϸɶ ޼  ]
'EXTERN LONG (__stdcall *cemHomeMoveAll)        (__in LONG NumAxes, __in PLONG AxisList, __in LONG IsBlocking);
'    ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
'[NumAxes: ۾   , AxisList:   迭 ּ]
'EXTERN LONG (__stdcall *cemHomeMoveAllStart)   (__in LONG NumAxes, __in PLONG AxisList);
'     Ϸ ¸ Ȯ.
' [Axis:   ȣ, IsSuccess:      Ϸ  ȯ]
Public Declare Function cemHomeSuccess_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef IsSuccess As Long) _
As Long

'     Ϸ ¸  .
' [Axis:   ȣ, IsSuccess:    θ  ]
Public Declare Function cemHomeSuccess_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal IsSuccess As Long) _
As Long

'   ¸ ȯ.
' [Axis:   ȣ, IsBusy:     ȯ]
Public Declare Function cemHomeIsBusy _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef IsBusy As Long) _
As Long

'  Ϸ ñ .
' [Channel:   ȣ, IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemHomeWaitDone _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal IsBlocking As Long) _
As Long

'****************************************************************************
'*************** START OF SINGLE AXIS CONTROL FUNCTION DECLARATIONS *********
'****************************************************************************
'    ش ࿡  ӵ  ӵ .
' [Axis:   ȣ, SpeedMode: ӵ , VelRatio: ۾ӵ (%), AccRatio: ӵ (%), DecRatio: ӵ (%)]
Public Declare Function cemSxSpeedRatio_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal SpeedMode As Long, ByVal VelRatio As Double, ByVal AccRatio As Double, ByVal DecRatio As Double) _
As Long

'    ش ࿡  ӵ  ӵ  ¸ ȯ.
' [Axis:   ȣ, SpeedMode: ӵ  ȯ, VelRatio: ۾ӵ (%) ȯ, AccRatio: ӵ (%) ȯ, DecRatio: ӵ (%) ȯ]
Public Declare Function cemSxSpeedRatio_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef SpeedMode As Long, ByRef VelRatio As Double, ByRef AccRatio As Double, ByRef DecRatio As Double) _
As Long

'   ǥ ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [Axis:   ȣ, Distance: ̵ Ÿ, IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemSxMove _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Distance As Double, ByVal IsBlocking As Long) _
As Long

'   ǥ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [Axis:   ȣ, Distance: ̵ Ÿ]
Public Declare Function cemSxMoveStart _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Distance As Double) _
As Long

'   ǥ ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [Axis:   ȣ, Distance: ̵  ǥ, IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemSxMoveTo _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Position As Double, ByVal IsBlocking As Long) _
As Long

'   ǥ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [Axis:   ȣ, Distance: ̵  ǥ ]
Public Declare Function cemSxMoveToStart _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Position As Double) _
As Long

'   ӵ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [Axis:   ȣ, Direction:  ̼ ]
Public Declare Function cemSxVMoveStart _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Direction As Long) _
As Long

'  ̼   .
' [Axis:   ȣ, IsWaitComplete:  Ϸɶ Լ ȯ , IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemSxStop _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal IsWaitComplete As Long, ByVal IsBlocking As Long) _
As Long

'  ̼  .
' [Axis:   ȣ]
Public Declare Function cemSxStopEmg _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long) _
As Long

'  ̼ Ϸ Ȯ.
' [Axis:   ȣ, IsDone:  ۾ Ϸ  ȯ]
Public Declare Function cemSxIsDone _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef IsDone As Long) _
As Long

'  ̼ Ϸ  .
' [Axis:   ȣ, IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemSxWaitDone _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal IsBlocking As Long) _
As Long

' ش  ࿡   ̼( or  ǥ) ġ ȯ.
' [Channel:   ȣ, Position:  ̼ ġ  ȯ]
Public Declare Function cemSxTargetPos_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef Position As Double) _
As Long

'   ʱ ӵ .
' [Axis:   ȣ, IniSpeed: ʱ ӵ]
Public Declare Function cemSxOptIniSpeed_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal IniSpeed As Double) _
As Long

'   ʱ ӵ  ȯ.
' [Axis:   ȣ, IniSpeed: ʱ ӵ ȯ]
Public Declare Function cemSxOptIniSpeed_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef IniSpeed As Double) _
As Long

'   RDP  
' [Axis:  (ä)ȣ, OffsetDist:RDP ġ]
Public Declare Function cemSxOptRdpOffset_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal OffsetDist As Double) _
As Long

'   RDP  ȯ
' [Axis:  (ä)ȣ, OffsetDist:RDP ġ ȯ]
Public Declare Function cemSxOptRdpOffset_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef OffsetDist As Double) _
As Long

'    ǥ 2ܰ ӵ ̼ .  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [Axis:   ȣ, Distance: ̵ Ÿ( ǥ ), Vel2: 2ܰ ۾ ӵ]
Public Declare Function cemSxMoveStart2V _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Distance As Double, ByVal Vel2 As Double) _
As Long

'    ǥ 2ܰ ӵ ̼ .  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [Axis:  ³ ȣ, Position: ̵ ġ ( ǥ ), Vel2: 2ܰ ۾ ӵ]
Public Declare Function cemSxMoveToStart2V _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Position As Double, ByVal Vel2 As Double) _
As Long

'   鷡 Ȥ    .
' [Axis:   ȣ, CorrMode:  , CorrAmount:  ޽ , CorrVel:  ޽  ļ, CntrMask:  ޽ ½ ī  ]
Public Declare Function cemSxCorrection_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal CorrMode As Long, ByVal CorrAmount As Double, ByVal CorrVel As Double, ByVal CntrMask As Long) _
As Long

'   鷡 Ȥ    ȯ.
' [Axis:   ȣ, CorrMode:   ȯ, CorrAmount:  ޽  ȯ, CorrVel:  ޽  ļ ȯ, CntrMask:  ޽ ½ ī   ȯ]
Public Declare Function cemSxCorrection_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef CorrMode As Long, ByRef CorrAmount As Double, ByRef CorrVel As Double, ByRef CntrMask As Long) _
As Long

'  ٸ    ȯ .
' [Axis:   ȣ, Mode:  , RefAxis:   ȣ ߻Ҷ   Ȥ ũ, Condition:   ȣ ߻ ]
'EXTERN LONG (__stdcall *cemSxOptSyncMode_Set)  (__in LONG Axis, __in LONG Mode, __in LONG RefAxis, __in LONG Condition);
'  ٸ   ۿ   ȯ.
' [Axis:   ȣ, Mode:   ȯ, RefAxis:   ȣ ߻Ҷ   Ȥ ũ ȯ, Condition:   ȣ ߻  ȯ]
'EXTERN LONG (__stdcall *cemSxOptSyncMode_Get)  (__in LONG Axis, __out PLONG Mode, __out PLONG RefAxis, __out PLONG Condition);
'  ӵ     .
' [Axis:   ȣ, Mode:    ߻ , DoChan_local:   ä ȣ, DoLogic:   ä ]
'EXTERN LONG (__stdcall *cemSxOptSyncOut_Set)   (__in LONG Axis, __in LONG Mode, __in LONG DoChan_local, __in LONG DoLogic);
'  ӵ      ȯ.
' [Axis:   ȣ, Mode:    ߻  ȯ, DoChan_local:   ä ȣ ȯ, DoLogic:   ä  ȯ]
'EXTERN LONG (__stdcall *cemSxOptSyncOut_Get)   (__in LONG Axis, __out PLONG Mode, __out PLONG DoChan_local, __out PLONG DoLogic);
' RDP(Ramping Down Point)  . (   ġ .)
' [Axis:   ȣ, OffsetDist: RDP Offset  Ÿ]
'EXTERN LONG (__stdcall *cemSxOptRdpOffset_Set) (__in LONG Axis, __in DOUBLE OffsetDist);
' RDP(Ramping Down Point)  ȯ. (   ġ ȯ.)
' [Axis:   ȣ, OffsetDist: RDP Offset  Ÿ ȯ]
'EXTERN LONG (__stdcall *cemSxOptRdpOffset_Get) (__in LONG Axis, __out PDOUBLE OffsetDist);
'****************************************************************************
'*************** START OF MULTIPLE AXES CONTROL FUNCTION DECLARATIONS *******
'****************************************************************************
'   ǥ ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [NumAxes:   , AxisList:   迭 ּ, DistList: ̵ Ÿ 迭 ּ, IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemMxMove _
Lib "ceSDKDLL.dll" _
(ByVal NumAxes As Long, ByRef AxisList As Long, ByRef DistList As Double, ByVal IsBlocking As Long) _
As Long

'   ǥ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
'[NumAxes:   , AxisList:   迭 ּ, DistList: ̵ Ÿ(ǥ) 迭 ּ]
Public Declare Function cemMxMoveStart _
Lib "ceSDKDLL.dll" _
(ByVal NumAxes As Long, ByRef AxisList As Long, ByRef DistList As Double) _
As Long

'   ǥ ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [NumAxes:   , AxisList:   迭 ּ, PosList: ̵ ġ(ǥ) 迭 ּ, IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemMxMoveTo _
Lib "ceSDKDLL.dll" _
(ByVal NumAxes As Long, ByRef AxisList As Long, ByRef PosList As Double, ByVal IsBlocking As Long) _
As Long

'   ǥ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [NumAxes:   , AxisList:   迭 ּ, PosList: ̵ ġ(ǥ) 迭 ּ]
Public Declare Function cemMxMoveToStart _
Lib "ceSDKDLL.dll" _
(ByVal NumAxes As Long, ByRef AxisList As Long, ByRef PosList As Double) _
As Long

'  Ӽӵ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [NumAxes:   , AxisList:   迭 ּ, DirList:  ϴ  迭 ּ]
Public Declare Function cemMxVMoveStart _
Lib "ceSDKDLL.dll" _
(ByVal NumAxes As Long, ByRef AxisList As Long, ByRef DirList As Long) _
As Long

'  ̼ Ȥ  .
' [NumAxes:   , AxisList:   迭 ּ, IsWaitComplete:  Ϸɶ Լ ȯ , IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemMxStop _
Lib "ceSDKDLL.dll" _
(ByVal NumAxes As Long, ByRef AxisList As Long, ByVal IsWaitComplete As Long, ByVal IsBlocking As Long) _
As Long

'  ̼  .
' [NumAxes:   , AxisList:   迭 ּ]
Public Declare Function cemMxStopEmg _
Lib "ceSDKDLL.dll" _
(ByVal NumAxes As Long, ByRef AxisList As Long) _
As Long

'  ̼ Ϸ Ȯ.
' [NumAxes:   , AxisList:   迭 ּ, IsDone: ۾ Ϸ  ȯ]
Public Declare Function cemMxIsDone _
Lib "ceSDKDLL.dll" _
(ByVal NumAxes As Long, ByRef AxisList As Long, ByRef IsDone As Long) _
As Long

'  ̼ Ϸ  .
' [NumAxes:   , AxisList:   迭 ּ, IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemMxWaitDone _
Lib "ceSDKDLL.dll" _
(ByVal NumAxes As Long, ByRef AxisList As Long, ByVal IsBlocking As Long) _
As Long

'****************************************************************************
'*************** START OF INTERPOLATION CONTROL FUNCTION DECLARATIONS *******
'****************************************************************************
'    ׷ .
' [MapIndex:  ȣ(0~7), NodeID:  ȣ, MapMask1:  ʿ    ũ( 32Ʈ, BIT0~BIT31),
' MapMask2:  ʿ    ũ( 32Ʈ, BIT32~BIT63)]
Public Declare Function cemIxMapAxes _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal NodeID As Long, ByVal MapMask1 As Long, ByVal MapMask2 As Long) _
As Long

'  ӵ   [MapIndex:  ȣ, ɼ1: VelCorrOpt1, ɼ2: VelCorrOpt2]
Public Declare Function cemIxVelCorrMode_Set _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal VelCorrOpt1 As Long, ByVal VelCorrOpt2 As Long) _
As Long

'  ӵ  ȯ [MapIndex:  ȣ, ɼ1: VelCorrOpt1, ɼ2: VelCorrOpt2]
Public Declare Function cemIxVelCorrMode_Get _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByRef VelCorrOpt1 As Long, ByRef VelCorrOpt2 As Long) _
As Long

'    ׷  .
' [MapIndex:  ȣ]
Public Declare Function cemIxUnMap _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long) _
As Long

'  ̼ ӵ .
' [MapIndex:  ȣ, IsVectorSpeed:  Ȥ  ǵ  , SpeedMode: ӵ , Vel: ۾ ӵ, Acc: ӵ, Dec: ӵ]
Public Declare Function cemIxSpeedPattern_Set _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal IsVectorSpeed As Long, ByVal SpeedMode As Long, ByVal Vel As Double, ByVal Acc As Double, ByVal Dec As Double) _
As Long

'  ̼ ӵ  ȯ.
' [MapIndex:  ȣ, IsVectorSpeed:  Ȥ  ǵ   ȯ, SpeedMode: ӵ  ȯ, Vel: ۾ ӵ ȯ, Acc: ӵ ȯ, Dec: ӵ ȯ]
Public Declare Function cemIxSpeedPattern_Get _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByRef IsVectorSpeed As Long, ByRef SpeedMode As Long, ByRef Vel As Double, ByRef Acc As Double, ByRef Dec As Double) _
As Long

'   ǥ ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [MapIndex:  ȣ, DistList: ̵ Ÿ(ǥ) 迭 ּ, IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemIxLine _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByRef DistList As Double, ByVal IsBlocking As Long) _
As Long

'   ǥ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [MapIndex:  ȣ, DistList: ̵ Ÿ(ǥ) 迭 ּ]
Public Declare Function cemIxLineStart _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByRef DistList As Double) _
As Long

'   ǥ ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [MapIndex:  ȣ, PosList: ̵ ġ(ǥ) 迭 ּ, IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemIxLineTo _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByRef PosList As Double, ByVal IsBlocking As Long) _
As Long

'   ǥ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [MapIndex:  ȣ, PosList: ̵ ġ(ǥ) 迭 ּ]
Public Declare Function cemIxLineToStart _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByRef PosList As Double) _
As Long

' ȣ  ǥ( ߽ǥ ) ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [MapIndex:  ȣ, XCentOffset:  ġκ  ߽ɱ X ǥ, YCentOffset:  ġ  ߽ɱ Y ǥ,
' EndAngle: ȣ  Ϸ ǥ  ġ  (Degree), IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemIxArcA _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal XCentOffset As Double, ByVal YCentOffset As Double, ByVal EndAngle As Double, ByVal IsBlocking As Long) _
As Long

' ȣ  ǥ( ߽ǥ ) ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [MapIndex:  ȣ, XCentOffset:  ġκ  ߽ɱ X ǥ, YCentOffset:  ġκ  ߽ɱ Y ǥ,
' EndAngle: ȣ  Ϸ ǥ   ġ  (Degree)]
Public Declare Function cemIxArcAStart _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal XCentOffset As Double, ByVal YCentOffset As Double, ByVal EndAngle As Double) _
As Long

' ȣ  ǥ( ߽ǥ ) ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [MapIndex:  ȣ, XCent: ߽ X ǥ, YCent: ߽ Y ǥ,
' EndAngle: ȣ  Ϸ ǥ   ġ  (Degree), IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemIxArcATo _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal XCent As Double, ByVal YCent As Double, ByVal EndAngle As Double, ByVal IsBlocking As Long) _
As Long

' ȣ  ǥ( ߽ǥ ) ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [MapIndex:  ȣ, XCent: ߽ X ǥ, YCent: ߽ Y ǥ, EndAngle: ȣ  Ϸ ǥ   ġ  (Degree)]
Public Declare Function cemIxArcAToStart _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal XCent As Double, ByVal YCent As Double, ByVal EndAngle As Double) _
As Long

' ȣ ǥ( ߽ǥ ǥ) ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [MapIndex:  ȣ, XCentOffset:  ġ  ߽ɱ X Ÿ, YCentOffset:  ġ  ߽ɱ Y Ÿ,
' XEndPointDist: ȣ ̵ Ϸ ǥ  ġκ X Ÿ, YEndPointDist: ȣ  ̵ Ϸ ǥ ġ  Y Ÿ, Direction: ȸ , IsBlocking: Ϸɶ ޼   ]
Public Declare Function cemIxArcP _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal XCentOffset As Double, ByVal YCentOffset As Double, ByVal XEndPointDist As Double, ByVal YEndPointDist As Double, ByVal Direction As Long, ByVal IsBlocking As Long) _
As Long

' ȣ ǥ( ߽ǥ ǥ) ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [MapIndex:  ȣ, XCentOffset:  ġ  ߽ɱ X Ÿ, YCentOffset:  ġ  ߽ɱ Y Ÿ,
' XEndPointDist: ȣ  ̵ Ϸ ǥ ġ  X Ÿ, YEndPointDist: ȣ  ̵ Ϸ ǥ ġ  Y Ÿ, Direction: ȸ ]
Public Declare Function cemIxArcPStart _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal XCentOffset As Double, ByVal YCentOffset As Double, ByVal XEndPointDist As Double, ByVal YEndPointDist As Double, ByVal Direction As Long) _
As Long

' ȣ ǥ( ߽ǥ ǥ) ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [MapIndex:  ȣ, XCent: ߽ X ǥ, YCent: ߽ Y ǥ, XEndPointDist: ȣ ̵ Ϸ ǥ X ǥ,
' YEndPointDist: ȣ ̵ Ϸ ǥ Y ǥ, Direction: ȸ , IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemIxArcPTo _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal XCent As Double, ByVal YCent As Double, ByVal XEndPointDist As Double, ByVal YEndPointDist As Double, ByVal Direction As Long, ByVal IsBlocking As Long) _
As Long

' ȣ ǥ( ߽ǥ ǥ) ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [MapIndex:  ȣ, XCent: ߽ X ǥ, YCent: ߽ Y ǥ, XEndPointDist: ȣ ̵ Ϸ ǥ X ǥ,
' YEndPointDist: ȣ ̵ Ϸ ǥ Y ǥ, Direction: ȸ ]
Public Declare Function cemIxArcPToStart _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal XCent As Double, ByVal YCent As Double, ByVal XEndPointDist As Double, ByVal YEndPointDist As Double, ByVal Direction As Long) _
As Long

' 3(Point)  ȣ ǥ ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [MapIndex:  ȣ, P2X:  ġ 2°  X ǥ, P2Y:  ġ 2°  Y ǥ,
' P3X: 2°  3°  X ǥ, P3Y: 2°  3°  Y ǥ, EndAngle: , IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemIxArc3P _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal P2X As Double, ByVal P2Y As Double, ByVal P3X As Double, ByVal P3Y As Double, ByVal EndAngle As Double, ByVal IsBlocking As Long) _
As Long

' 3(Point)  ȣ ǥ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [MapIndex:  ȣ, P2X:  ġ 2°  X ǥ, P2Y:  ġ 2°  Y ǥ,
' P3X: 2°  3°  X ǥ, P3Y: 2°  3°  Y ǥ, EndAngle: ]
Public Declare Function cemIxArc3PStart _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal P2X As Double, ByVal P2Y As Double, ByVal P3X As Double, ByVal P3Y As Double, ByVal EndAngle As Double) _
As Long

' 3(Point)  ȣ ǥ ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [MapIndex:  ȣ, P2X: 2°  X ǥ, P2Y: 2°  Y ǥ,
' P3X: 3°  X ǥ, P3Y: 3°  Y ǥ, EndAngle: , IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemIxArc3PTo _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal P2X As Double, ByVal P2Y As Double, ByVal P3X As Double, ByVal P3Y As Double, ByVal EndAngle As Double, ByVal IsBlocking As Long) _
As Long

' 3(Point)  ȣ ǥ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [MapIndex:  ȣ, P2X: 2°  X ǥ, P2Y: 2°  Y ǥ, P3X: 3°  X ǥ, P3Y: 3°  Y ǥ, EndAngle: ]
Public Declare Function cemIxArc3PToStart _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal P2X As Double, ByVal P2Y As Double, ByVal P3X As Double, ByVal P3Y As Double, ByVal EndAngle As Double) _
As Long

'    ̼   .
' [MapIndex:  ȣ]
Public Declare Function cemIxStop _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long) _
As Long

'    ̼ .
' [MapIndex:  ȣ]
Public Declare Function cemIxStopEmg _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long) _
As Long

'    ̼  Ϸ Ȯ.
' [MapIndex:  ȣ, IsDone:    ̼  Ϸ ]
Public Declare Function cemIxIsDone _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByRef IsDone As Long) _
As Long

'    ̼  Ϸ  .
' [MapIndex:  ȣ, IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemIxWaitDone _
Lib "ceSDKDLL.dll" _
(ByVal MapIndex As Long, ByVal IsBlocking As Long) _
As Long

' ︮  ̼ ӵ    ȯ .
' [HelId: ︮  ̼ ۾ ID, Master:  ӵ  , SpeedMode: ӵ , WorkSpeed: ۾ ӵ, Acc:ӵ, Dec:ӵ]
' EXTERN LONG (__stdcall *cemIxxHelOnceSpeed_Set)       (__in LONG HelId, __in LONG Master, __in LONG SpeedMode, __in DOUBLE WorkSpeed, __in DOUBLE Acc, __in DOUBLE Dec);
' ︮  ̼ ӵ    ȯ  ȯ.
' [HelId: ︮  ̼ ۾ ID, Master:  ӵ  ȯ, SpeedMode: ӵ  ȯ, WorkSpeed: ۾ ӵ ȯ, Acc:ӵ ȯ, Dec:ӵ ȯ]
' EXTERN LONG (__stdcall *cemIxxHelOnceSpeed_Get)       (__in LONG HelId, __out PLONG SpeedMaster, __out PLONG SpeedMode, __out PDOUBLE WorkSpeed, __out PDOUBLE Acc, __out PDOUBLE Dec);
' ︮ ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [HelId: ︮  ̼ ۾ ID, NumAxes: ︮  Ǵ  (3 or 4), AxisList:   迭 ּ,
' CoordList: ǥ 迭 ּ, ArcAngle: ȣ  ̵ , DistU: U ̼ Ÿ ȯ, IsBlocking: Ϸɶ ޼  ]
' EXTERN LONG (__stdcall *cemIxxHelOnce)        (__in LONG HelId, __in LONG NumAxes, __in PLONG AxisList, __in PDOUBLE CoordList, __in DOUBLE ArcAngle, __out PDOUBLE DistU, __in LONG IsBlocking);
' ︮ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [HelId: ︮  ̼ ۾ ID, NumAxes: ︮  Ǵ  (3 or 4), AxisList:   迭 ּ,
' CoordList: ǥ 迭 ּ, ArcAngle: ȣ  ̵ , DistU: U ̼ Ÿ ȯ]
' EXTERN LONG (__stdcall *cemIxxHelOnceStart)   (__in LONG HelId, __in Long NumAxes, __in PLONG AxisList, __in PDOUBLE CoordList, __in DOUBLE ArcAngle, __out PDOUBLE DistU);
' Cubic Spline   ǥ ǥ .
' [InArray: ö     Ʈ 迭, NumInArray:   ,
' OutArray: ö  Ͽ ڵ   ͸  迭 ּ, NumOutArray: ö  Ͽ ڵ   ]
' EXTERN LONG (__stdcall *cemIxxSplineBuild)    (__in PDOUBLE InArray, __in LONG NumInArray, __out PDOUBLE OutArray, __in LONG NumOutArray);
'****************************************************************************
'*************** START OF MASTER/SLAVE CONTROL FUNCTION DECLARATIONS ********
'****************************************************************************
'   ࿡ ؼ, Master/Slave   Slave  .
' [Axis: Slave     ȣ, MaxSpeed: Slave  ִ ӵ, IsInverse: Slave  Master  ݴ Ұ ]
Public Declare Function cemMsRegisterSlave _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal MaxSpeed As Double, ByVal IsInverse As Long) _
As Long

'   ࿡ ؼ, Master/Slave   Slave  .
' [Axis: Slave ࿡    ȣ]
Public Declare Function cemMsUnregisterSlave _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long) _
As Long

'   ࿡ ؼ, Master/Slave   Slave    ȯ.
' [SlaveAxis: Slave ¸ Ȯ    ȣ, SlaveState: Slave   ȯ]
Public Declare Function cemMsCheckSlaveState _
Lib "ceSDKDLL.dll" _
(ByVal SlaveAxis As Long, ByRef SlaveState As Long) _
As Long

'   ࿡ ؼ, Master/Slave   Master    ȣ Ȯ.
' [SlaveAxis: Slave   ȣ, MasterAxis: Master   ȣ]
Public Declare Function cemMsMasterAxis_Get _
Lib "ceSDKDLL.dll" _
(ByVal SlaveAxis As Long, ByRef MasterAxis As Long) _
As Long

'****************************************************************************
'*************** START OF Manual Pulsar FUNCTION SECTION ********************
'****************************************************************************
' Manual Pulsar Է ȣ  ȯ漳.
' [Channel:   ȣ, InputMode: Pulsar Է ȣ Է , IsInverse: Pulsar Է ȣ Ÿ    ġ ]
Public Declare Function cemPlsrInMode_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal InputMode As Long, ByVal IsInverse As Long) _
As Long

' Manual Pulsar Է ȣ  ȯ漳 ȯ.
' [Channel:   ȣ, InputMode: Pulsar Է ȣ Է  ȯ, Pulsar Է ȣ Ÿ    ġ  ȯ]
Public Declare Function cemPlsrInMode_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef InputMode As Long, ByRef IsInverse As Long) _
As Long

' Manual Pulsar PA/PB Է޽ , ޽    .
' [Channel:   ȣ, GainFactor: PMG ȸο Ǵ  (1~32), DivFactor: PDIV ȸο Ǵ  (1~2048)]
Public Declare Function cemPlsrGain_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal GainFactor As Long, ByVal DivFactor As Long) _
As Long

' Manual Pulsar PA/PB Է޽ , ޽     ȯ.
' [Channel:   ȣ, GainFactor: PMG ȸο Ǵ   ȯ, DivFactor: PDIV ȸο Ǵ   ȯ]
Public Declare Function cemPlsrGain_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef GainFactor As Long, ByRef DivFactor As Long) _
As Long

'
' Manual Pulsar Է ȣ   ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [Channel:   ȣ, HomeType: Pulsar Input     ]
Public Declare Function cemPlsrHomeMoveStart _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal HomeType As Long) _
As Long

' Manual Pulsar Է ȣ  ǥ ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [Channel:   ȣ, Distance: ̵ Ÿ(ǥ), IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemPlsrMove _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal Distance As Double, ByVal IsBlocking As Long) _
As Long

' Manual Pulsar Է ȣ  ǥ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [Channel:   ȣ, Distance: ̵ Ÿ(ǥ)]
Public Declare Function cemPlsrMoveStart _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal Distance As Double) _
As Long

' Manual Pulsar Է ȣ  ǥ ̼.  Լ  ϷǱ  ȯ ʽϴ.
' [Channel:   ȣ, Position: ̵ ġ(ǥ), IsBlocking: Ϸɶ ޼  ]
Public Declare Function cemPlsrMoveTo _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal Position As Double, ByVal IsBlocking As Long) _
As Long

' Manual Pulsar Է ȣ  ǥ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [Channel:   ȣ, Position: ̵ ġ(ǥ)]
Public Declare Function cemPlsrMoveToStart _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal Position As Double) _
As Long

' Manual Pulsar Է ȣ  Ӽӵ ̼.  Լ  ۽Ų Ŀ ٷ ȯ˴ϴ.
' [Channel:   ȣ]
Public Declare Function cemPlsrVMoveStart _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long) _
As Long

'****************************************************************************
'*************** START OF OVERRIDE FUNCTION DECLARATIONS ********************
'****************************************************************************
'  ̼ ۾ ߿ ӵ .
' [Axis:   ȣ]
Public Declare Function cemOverrideSpeedSet _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long) _
As Long

'  ̼ ۾ ߿  鿡 Ͽ ÿ ӵ .
' [NumAxes : ÿ ۾    , AxisList : ÿ ۾    迭 ּ]
' EXTERN LONG (__stdcall *cemOverrideSpeedSetAll)       (__in LONG NumAxes, __in LONG AxisList);
' ǥ ̼ ߿, ǥ ǥ  Ÿ .
' [Axis:   ȣ, NewDistance: ο ǥ Ÿ(ǥ), IsHardApply: Override Ұ , Override    , AppliedState: Override    ȯ]
Public Declare Function cemOverrideMove _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal NewDistance As Double, ByVal IsHardApply As Long, ByRef AppliedState As Long) _
As Long

' ǥ ̼ ߿, ǥ ǥ  Ÿ .
' [Axis:   ȣ, NewPosition: ο ǥ Ÿ(ǥ), IsHardApply: Override Ұ , Override    , AppliedState: Override    ȯ]
Public Declare Function cemOverrideMoveTo _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal NewPosition As Double, ByVal IsHardApply As Long, ByRef AppliedState As Long) _
As Long

'****************************************************************************
'*************** START OF MONITORING FUNCTION DECLARATIONS ******************
'****************************************************************************
'    ϵ ī (޽) . Target  ceSDKDef.h Ͽ ǵ enum _TCnmCntr  Ʈ .
' [Axis:   ȣ, Target:  ī ȣ, Count:  ī (PPS)]
Public Declare Function cemStCount_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Target As Long, ByVal Count As Long) _
As Long

'    ϵ ī (޽) ȯ. Target  ceSDKDef.h Ͽ ǵ enum _TCnmCntr  Ʈ .
' [Axis:   ȣ, Source:   ī ȣ, Count:  ī (PPS) ȯ]
Public Declare Function cemStCount_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Source As Long, ByRef Count As Long) _
As Long

'     ī ( Ÿ) . Target  ceSDKDef.h Ͽ ǵ enum _TCnmCntr  Ʈ .
' [Axis:   ȣ, Target:  ī ȣ, Position:  ī ( Ÿ)]
Public Declare Function cemStPosition_Set _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Target As Long, ByVal Position As Double) _
As Long

'     ī ( Ÿ) ȯ. Target  ceSDKDef.h Ͽ ǵ enum _TCnmCntr  Ʈ .
' [Axis:   ȣ, Source:   ī ȣ, Position:  ī ( Ÿ) ȯ]
Public Declare Function cemStPosition_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Source As Long, ByRef Position As Double) _
As Long

'    ӵ ȯ. Target  ceSDKDef.h Ͽ ǵ enum _TCnmCntr  Ʈ .
' [Axis:   ȣ, Source: ӵ ȯ Ǵ ī ȣ, Speed:  Source ӵ( ӵ) ȯ]
Public Declare Function cemStSpeed_Get _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Source As Long, ByRef Speed As Double) _
As Long

'      ȯ.
' [Axis:   ȣ, MotStates:   ȯ]
Public Declare Function cemStReadMotionState _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef MotStates As Long) _
As Long

'     I/O  ȯ.
' [Axis:   ȣ, MiotStates: Machine I/O  ȯ]
Public Declare Function cemStReadMioStatuses _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef MioStates As Long) _
As Long

'  ۻ¿ õ ڿ ȯ. cemStReadMotionState() Լ    .
' [MstCode:    , Buffer:  ۻ¸  ڿ  ּ ȯ, Bufferlen: ڿ  ]
Public Declare Function cemStGetMstString _
Lib "ceSDKDLL.dll" _
(ByVal MstCode As Long, ByRef Buffer As String, ByVal BufferLen As Long) _
As Long

' ŵ I/O ޽  ȯ.
' [IOMessageCount: I/O ޽ ]
Public Declare Function cemStReadIOMessageCount _
Lib "ceSDKDLL.dll" _
(ByRef IOMessageCount As Double) _
As Long

'****************************************************************************
'*************** START OF LTC FUNCTION DECLARATIONS *************************
'****************************************************************************
' ش LTC ī Ȱȭ  Ȯ [Axis: (ä)ȣ, IsLatched: ī Ȱȭ  ȯ]
Public Declare Function cemLtcIsLatched _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByRef IsLatched As Long) _
As Long

' ش LTC ī  Ȯ [Axis: (ä)ȣ, Counter:  ī, LatchedPos:   ġ īƮ  ȯ]
Public Declare Function cemLtcReadLatch _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long, ByVal Counter As Long, ByRef LatchedPos As Double) _
As Long

'****************************************************************************
'*************** START OF ADVANCED FUNCTION DECLARATIONS ********************
'****************************************************************************
' Undocument Function Դϴ.  Լ  ̳   ˴ϴ.
Public Declare Function cemAdvGetNodeInformation _
Lib "ceSDKDLL.dll" _
(ByVal nNode As Long, ByVal TargetNode As Any) _
As Long

' Undocument Function Դϴ.  Լ  ̳   ˴ϴ.
Public Declare Function cemAdvGetAllNodeInformation _
Lib "ceSDKDLL.dll" _
(ByVal InformationpTargetNodes As Any) _
As Long

' Undocument Function Դϴ.  Լ  ̳   ˴ϴ.
Public Declare Function cmnAdvDownloadDefaultConfigure _
Lib "ceSDKDLL.dll" _
() _
As Long

' Undocument Function Դϴ.  Լ  ̳   ˴ϴ.
Public Declare Function cemAdvUploadConfigure _
Lib "ceSDKDLL.dll" _
(ByVal FileType As Long, ByRef FileName As String) _
As Long

' Undocument Function Դϴ.  Լ  ̳   ˴ϴ.
Public Declare Function cemAdvDownloadConfigure _
Lib "ceSDKDLL.dll" _
(ByVal FileType As Long, ByRef FileName As String) _
As Long

' Undocument Function Դϴ.  Լ  ̳   ˴ϴ.
Public Declare Function cemAdvActiveNodeCount_Get _
Lib "ceSDKDLL.dll" _
(ByRef NumNode As Long) _
As Long

' Undocument Function Դϴ.  Լ  ̳   ˴ϴ.
Public Declare Function cemAdvActiveNodeID_Get _
Lib "ceSDKDLL.dll" _
(ByVal ArraySize As Long, ByRef lArray As Long, ByRef NumNode As Long) _
As Long

' ش ࿡ ERC ȣ մϴ.
Public Declare Function cemAdvErcOut _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long) _
As Long

' ش ࿡ ERC ȣ  մϴ.
Public Declare Function cemAdvErcReset _
Lib "ceSDKDLL.dll" _
(ByVal Axis As Long) _
As Long

' Undocument Function Դϴ.  Լ  ̳   ˴ϴ.
Public Declare Function cemAdvManualPacket _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal CommandNo As Long, ByRef SendBuffer As Double, ByVal NumSendData As Long, ByRef RecvBuffer As Double, ByVal NumRecvData As Long, ByVal SendFlag As Long, ByVal RecvFlag As Long) _
As Long

'****************************************************************************
'*************** START OF SYSTEM DIO CONFIGURATION FUNCTION DECLARATIONS ****
'****************************************************************************
' ý   Ǵ ǰ  äο ؼ Է Ȯմϴ.
Public Declare Function cemDiOne_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef State As Long) _
As Long

' ý   Ǵ ǰ  äο ؼ Է Ȯմϴ.
Public Declare Function cemDiMulti_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChannel As Long, ByVal NumChannels As Long, ByRef InputState As Long) _
As Long

' ý   Ǵ ǰ  äο ؼ  ߻մϴ.
Public Declare Function cemDoOne_Put _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal OutState As Long) _
As Long

' ý   Ǵ ǰ  äο ؼ  Ȯմϴ.
Public Declare Function cemDoOne_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef OutState As Long) _
As Long

' ý   Ǵ ǰ  äο ؼ  ߻մϴ.
Public Declare Function cemDoMulti_Put _
Lib "ceSDKDLL.dll" _
(ByVal IniChannel As Long, ByVal NumChannels As Long, ByVal OutStates As Long) _
As Long

' ý   Ǵ ǰ  äο ؼ  Ȯմϴ.
Public Declare Function cemDoMulti_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChannel As Long, ByVal NumChannels As Long, ByRef OutStates As Long) _
As Long

'****************************************************************************
'*************** START OF INTERLOCK FUNCTION DECLARATIONS *******************
'****************************************************************************
Public Declare Function ceil_Set _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal Interlock_Type As Long, ByVal bEnable As Long) _
As Long

Public Declare Function ceil_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal Interlock_Type As Long, ByRef bIsEnabled As Long) _
As Long

Public Declare Function ceilDisconnectTimeout_Set _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal Interlock_Type As Long, ByVal dwTimeOut As Long) _
As Long

Public Declare Function ceilDisconnectTimeout_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal Interlock_Type As Long, ByRef pdwTimeOut As Long) _
As Long

Public Declare Function ceilActionModeOne_Set _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleType As Long, ByVal Channel As Long, ByVal ActionMode As Long) _
As Long

Public Declare Function ceilActionModeOne_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleType As Long, ByVal Channel As Long, ByRef pdwActionMode As Long) _
As Long

Public Declare Function ceilActionModeMulti_Set _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleType As Long, ByVal IniChan As Long, ByVal NumChan As Long, ByVal ActionModes As Long) _
As Long

Public Declare Function ceilActionModeMulti_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal ModuleType As Long, ByVal IniChan As Long, ByVal NumChan As Long, ByRef pdwActionModes As Long) _
As Long

'****************************************************************************
'*************** START OF DIO CONFIGURATION FUNCTION DECLARATIONS ***********
'****************************************************************************
'    ä  (Input/Output) .
' [Channel:  ä ȣ, InOutMode:  ]
Public Declare Function cedioMode_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal InOutMode As Long) _
As Long

'    ä  (Input/Output)   ȯ.
' [Channel:  ä ȣ, InOutMode:   ȯ]
Public Declare Function cedioMode_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef InOutMode As Long) _
As Long

'    ä    äο  ÿ  (Input/Output) .
' [IniChan:   ä ȣ, NumChan:  ä , InOutModeMask:   ũ]
Public Declare Function cedioModeMulti_Set _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByVal InOutModeMask As Long) _
As Long

'    ä    äο  ÿ  (Input/Output)   ȯ.
' [IniCahn:   ä ȣ, NumChan:  ä , InOutModeMask:   ũ ȯ]
Public Declare Function cedioModeMulti_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByRef InOutModeMask As Long) _
As Long

'    ä  (Logic) .
' [Channel:  ä ȣ, InputLogic:  ]
Public Declare Function cedioLogicOne_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal Logic As Long) _
As Long

'    ä  (Logic)   ȯ.
' [Channel:  ä ȣ, InputLogic:   ȯ]
Public Declare Function cedioLogicOne_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef Logic As Long) _
As Long

'    ä    äο  ÿ  (Logic) .
' [IniChan:   ä ȣ, NumChan:  ä , LogicMask:  (Logic) ũ]
Public Declare Function cedioLogicMulti_Set _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByVal LogicMask As Long) _
As Long

'    ä    äο  ÿ  (Logic)   ȯ
'   ä ³  ȯ [IniChan:   ä ȣ, NumChan: ä , LogicMask:  ũ]
Public Declare Function cedioLogicMulti_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByRef LogicMask As Long) _
As Long

'    ä Է Ǵ   ȯ.
' [Channel:  ä ȣ, OutState: ä  ȯ]
Public Declare Function cedioOne_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef State As Long) _
As Long

'    ä Է Ǵ   .
' [Channel:  ä ȣ, OutState: ä ]
Public Declare Function cedioOne_Put _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal State As Long) _
As Long

'    ä    äο  ÿ Է Ǵ  ¸ ȯ.
' [IniChan:   ä ȣ, NumChan:  ä , States: ä  ȯ]
Public Declare Function cedioMulti_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByRef States As Long) _
As Long

'    ä    äο  ÿ Է Ǵ  ¸ .
' [ IniChan:   ä ȣ, NumChan:  ä , States: ä ]
Public Declare Function cedioMulti_Put _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByVal States As Long) _
As Long

'    ä    Ȱȭ Ͽ  Է Ǵ  ¸ ȯ.
' [Channel:  ä ȣ, CutoffTime_us:  Է ȣ  ð(us), State: ä  ȯ]
Public Declare Function cedioOneF_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal CutoffTime_us As Long, ByRef State As Long) _
As Long

'    ä 
'    ä   
' [IniChan:   ä ȣ, NumChan: ä , CutoffTime_us:  Է ȣ  ð(us), InputStates: ش ä  Է ]
Public Declare Function cedioMultiF_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByVal CutoffTime_us As Long, ByRef States As Long) _
As Long

'    ä   ä   ޽  ߻
' [Channel:  ä ȣ, IsOnPulse:      ʱ ޽  ¸ , Duration: ޽  ð ,
' IsWaitPulseEnd: ޽  ۽ÿ Լ ٷ ȯ , ƴϸ ޽  ð Լ ȯ   ]
Public Declare Function cedioPulseOne _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal IsOnPulse As Long, ByVal Duration As Long, ByVal IsWaitPulseEnd As Long) _
As Long

'   ä     ä   ޽  ߻
' [IniChan:  ä, NumChan: ä , OutStates:   , Duration: ޽  ð ,
' IsWaitPulseEnd: ޽  ۽ÿ Լ ٷ ȯ , ƴϸ ޽  ð Լ ȯ   ]
Public Declare Function cedioPulseMulti _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByVal OutStates As Long, ByVal Duration As Long, ByVal IsWaitPulseEnd As Long) _
As Long

'****************************************************************************
'*************** START OF DI CONTROL FUNCTION DECLARATIONS ******************
'****************************************************************************
'   Է ä Է³ 
' [Channel:  ä ȣ, InputLogic: Է ]
Public Declare Function cediLogicOne_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal InputLogic As Long) _
As Long

'   Է ä Է³  ȯ
' [Channel:  ä ȣ, InputLogic: Է ]
Public Declare Function cediLogicOne_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef InputLogic As Long) _
As Long

'  Է ä Է³ 
' [IniChan:   ä ȣ, NumChan: ä , LogicMask:  ũ]
Public Declare Function cediLogicMulti_Set _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByVal LogicMask As Long) _
As Long

'  Է ä Է³  ȯ
' [IniChan:   ä ȣ, NumChan: ä , LogicMask:  ũ]
Public Declare Function cediLogicMulti_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByRef LogicMask As Long) _
As Long

'   Էä   Է ä ¸ ȯ
' [Channel:  ä ȣ, InputState:  Է ]
Public Declare Function cediOne_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef InputState As Long) _
As Long

'   Է ä    Է ä ¸ ȯ
' [IniChan:   ä ȣ, NumChan: ä , InputStates:  Է ]
Public Declare Function cediMulti_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByRef InputStates As Long) _
As Long

'   Է ä  ä     Ȱȭ Ͽ  Է ¸ ȯ
' [Channel:  ä ȣ, CutoffTime_us:  Է ȣ  ð(us), InputState: ش ä  Է ]
Public Declare Function cediOneF_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal CutoffTime_us As Long, ByRef InputState As Long) _
As Long

'   Է ä   
' [IniChan:   ä ȣ, NumChan: ä , CutoffTime_us:  Է ȣ  ð(us), InputStates: ش ä  Է ]
Public Declare Function cediMultiF_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByVal CutoffTime_us As Long, ByRef InputStates As Long) _
As Long

'****************************************************************************
'*************** START OF DO CONTROL FUNCTION DECLARATIONS ******************
'****************************************************************************
'    ä ³ 
' [Channel:  ä ȣ, OutputLogic:  ]
Public Declare Function cedoLogicOne_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal OutputLogic As Long) _
As Long

'    ä ³   ȯ
' [Channel:  ä ȣ, OutputLogic: ]
Public Declare Function cedoLogicOne_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef OutputLogic As Long) _
As Long

'   ä     ä  ÿ   ߻
' [IniChan:   ä ȣ, NumChan: ä , LogicMask:  ũ]
Public Declare Function cedoLogicMulti_Set _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByVal LogicMask As Long) _
As Long

'   ä     ä ¸ Ȯ
' [IniChan:   ä ȣ, NumChan: ä , LogicMask:  ũ]
Public Declare Function cedoLogicMulti_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByRef LogicMask As Long) _
As Long

'    ä   ä    ߻
' [Channel:  ä ȣ, OutState:  ]
Public Declare Function cedoOne_Put _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal OutState As Long) _
As Long

'    ä   ä    ¸ ȯ
' [Channel:  ä ȣ, OutState:   ]
Public Declare Function cedoOne_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef OutState As Long) _
As Long

'   ä     ä  ÿ   ߻
' [ IniChan:   ä ȣ, NumChan: ä , OutStates:   ]
Public Declare Function cedoMulti_Put _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByVal OutStates As Long) _
As Long

'   ä     ä  ÿ   ¸ Ȯ
' [IniChannel:   ä ȣ, NumChan: ä , OutStates:   ]
Public Declare Function cedoMulti_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByRef OutStates As Long) _
As Long

'    ä   ä   ޽  ߻
' [Channel:  ä ȣ, IsOnPulse:      ʱ ޽  ¸ ,
' IsWaitPulseEnd: ޽  ۽ÿ Լ ٷ ȯ , ƴϸ ޽  ð Լ ȯ   ]
Public Declare Function cedoPulseOne _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal IsOnPulse As Long, ByVal Duration As Long, ByVal IsWaitPulseEnd As Long) _
As Long

'   ä     ä   ޽  ߻
' [IniChan:   ä ȣ, NumChan: ä , OutStates:   , Duration: ޽  ð ,
' IsWaitPulseEnd: ޽  ۽ÿ Լ ٷ ȯ , ƴϸ ޽  ð Լ ȯ   ]
Public Declare Function cedoPulseMulti _
Lib "ceSDKDLL.dll" _
(ByVal IniChan As Long, ByVal NumChan As Long, ByVal OutStates As Long, ByVal Duration As Long, ByVal IsWaitPulseEnd As Long) _
As Long

'****************************************************************************
'*************** START OF COUNTER MODULE FUNCTION DECLARATIONS **************
'****************************************************************************
' īʹ  8ä  ֽϴ. (⺰  Channel 0 ~ Channel 7)
'  ī ä Edge Mode  մϴ.
' [Channel: ī äιȣ, EdgeMode: Edge 0(falling edge) 1(rising edge) Default:falling edge]
Public Declare Function cecEdgeOne_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal EdgeMode As Double) _
As Long

'  ī ä Edge Mode  ɴϴ
' [Channel: ī äιȣ, EdgeMode: Edge ȯ 0(falling edge) 1(rising edge)]
Public Declare Function cecEdgeOne_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef EdgeMode As Double) _
As Long

'  ī ä  Ե äε Edge Mode  Ƽ մϴ.
' [IniChannel:ä Range  ä ȣ, NumChannels:ä Range ũ, EdgeModeMask: äιȣ  ä ȣ  äκ Edge Mode  ش Ʈ 0/1   0(falling edge) 1(rising edge)]
Public Declare Function cecEdgeMulti_Set _
Lib "ceSDKDLL.dll" _
(ByVal IniChannel As Long, ByVal NumChannels As Long, ByVal EdgeModeMask As Double) _
As Long

'  ī ä  Ե äε Edge Mode  Ƽ ɴϴ. Ʈ ũ   ƮShift   äκ 0 Ǵ 1  (Edge Mode)    ֽϴ.
' [IniChannel:ä Range  ä ȣ, NumChannels:ä Range ũ, EdgeModeMask: äιȣ  ä ȣ  äκ Edge Mode  ش Ʈ 0/1    ȯ 0(falling edge) 1(rising edge)]
Public Declare Function cecEdgeMulti_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChannel As Long, ByVal NumChannels As Long, ByRef EdgeModeMask As Double) _
As Long

'  ī ä īƮ  Clear (0  ) ŵϴ.
' [Channel: ī äιȣ]
Public Declare Function cecClearOne _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long) _
As Long

'  ī ä  Ե äε īƮ   Clear (0  ) ŵϴ.
' [IniChannel:ä Range  ä ȣ, NumChannels:ä Range ũ]
Public Declare Function cecClearMulti _
Lib "ceSDKDLL.dll" _
(ByVal IniChannel As Long, ByVal NumChannels As Long) _
As Long

'  ī ä īƮ  Clear (0  ) ŵϴ.
' [NodeID:  ID - IP(192.168.1.x)  4° ڸ(x)]
Public Declare Function cecClearAll _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long) _
As Long

'  ī ä īƮ   ɴϴ.
' [Channel: ī äιȣ, Count: īƮ ]
Public Declare Function cec_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef Count As Double) _
As Long

'  ī ä īƮ ϵ մϴ. Enable: true (1) or false (0)
' [Channel: ī äιȣ, Enable: Count Enable ° 0: Diable 1: Enable]
Public Declare Function cecEnableOne_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal Enable As Double) _
As Long

'  ī ä īƮ   Counter Enable ¸  ɴϴ.
' [Channel: ī äιȣ, IsEnabled: Count Enable ° 0: Diable 1: Enable]
Public Declare Function cecEnableOne_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef IsEnabled As Double) _
As Long

'  ī ä  Ե äε īƮ ϵ Counter Enable ¸  true(1)  մϴ.
' [IniChannel:ä Range  ä ȣ, NumChannels:ä Range ũ, EnableMask: Ƽäο  Counter Enable ¸ũ ]
Public Declare Function cecEnableMulti_Set _
Lib "ceSDKDLL.dll" _
(ByVal IniChannel As Long, ByVal NumChannels As Long, ByVal EnableMask As Double) _
As Long

'  ī ä  Ե äε īƮ   Counter Enable ¸ ɴϴ. Ƽ äο  EnabledMask    ƮShift   äκ Enable ¸   ֽϴ.
' [IniChannel:ä Range  ä ȣ, NumChannels:ä Range ũ, EnabledMask: Ƽäο  Counter Enable ¸ũ ]
Public Declare Function cecEnableMulti_Get _
Lib "ceSDKDLL.dll" _
(ByVal IniChannel As Long, ByVal NumChannels As Long, ByRef EnabledMask As Double) _
As Long

'  ī ä Overflow (24Ʈ:0~2^24-1  ʰ) ¸  ɴϴ. 1:overflow
' [Channel: ī äιȣ, OverflowStatus: Count Overflow ° 0: Overflow ߻  1: Overflow ߻ ]
Public Declare Function cecOverflowFlagGetOne _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef OverflowStatus As Double) _
As Long

'  ī äι Overflow (24Ʈ  ʰ) ¸  ɴϴ.
' [IniChannel:ä Range  ä ȣ, NumChannels:ä Range ũ, OverflowStates: Ƽäο  Overflow ¸ũ ]
Public Declare Function cecOverflowFlagGetMulti _
Lib "ceSDKDLL.dll" _
(ByVal IniChannel As Long, ByVal NumChannels As Long, ByRef OverflowStates As Double) _
As Long

'  ī äο شϴ Overflow Flag  0  Clear ŵϴ.
' [Channel: ī äιȣ]
Public Declare Function cecOverflowFlagClearOne _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long) _
As Long

'  ī äι  شϴ äκ Overflow Flag  0  Clear ŵϴ.
' [IniChannel:ä Range  ä ȣ, NumChannels:ä Range ũ]
Public Declare Function cecOverflowFlagClearMulti _
Lib "ceSDKDLL.dll" _
(ByVal IniChannel As Long, ByVal NumChannels As Long) _
As Long

'  ī ä overflow flag  0  Clear ŵϴ.
' [NodeID:  ID - IP(192.168.1.x)  4° ڸ(x)]
Public Declare Function cecOverflowFlagClearAll _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long) _
As Long

'  ī äκ  Cutoff ļ : FilterFreq: 0~2   .
' [Channel: ī äιȣ, FilterFreq: äκ  Cutoff ļ]
'A      B        ļ             Cutoff ļ (50duty)  Filter passϱ  ּҽð
'0      0       10Mhz (default) 500Khz                                  1usec
'0      1       312Khz                  20Khz                                   25usec
'1      0       39Khz                   4Khz                                    125usec
Public Declare Function cecFilterFreq_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal FilterFreq As Long) _
As Long

'  ī äκ  Cutoff ļ   Լ =>  Լ ɼԴϴ.  ̺귯 ܵ  ֽϴ.
' [Channel: ī äιȣ, FilterFreq: äκ  Cutoff ļ]
Public Declare Function cecFilterFreq_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef FilterFreq As Long) _
As Long

'****************************************************************************
'*************** START OF ANALOG INPUT FUNCTION DECLARATIONS ****************
'****************************************************************************
' Ƴα Է¿     带  մϴ.
' [Channel: Ƴα Է ä ȣ, RangeMode:    ]
'RangeMode (0~3)
'A      B       Է¹
'0      0       +10V ~ -10V
'0      1       +5V ~ -5V
'1      0       +2.5V ~ -2.5V
'1      1       0V ~ +10V (0~20mA)
Public Declare Function ceaiVoltRangeMode_Set _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal RangeMode As Long) _
As Long

' Ƴα Է¿     شϴ 带 ȯմϴ.
' [Channel: Ƴα Է ä ȣ, RangeMode:    ]
Public Declare Function ceaiVoltRangeMode_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef RangeMode As Long) _
As Long

' Ƴα Է¿   Է Range  Digit  ȯմϴ =>  Լ Ŀ    ֽϴ.
' [Channel: Ƴα Է ä ȣ, DigitMin: ּ Է Digit , DigitMax: ִ Է Digit ]
Public Declare Function ceaiRangeDigit_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef DigitMin As Long, ByRef DigitMax As Long) _
As Long

' ش Ƴα Է ä Է Digit  ȯմϴ.
' [Channel: Ƴα Է ä ȣ, Digit: Էµ Digit ]
Public Declare Function ceaiDigit_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef Digit As Long) _
As Long

' ش Ƴα Է ä Է   ȯմϴ.
' [Channel: Ƴα Է ä ȣ, fVolt: Էµ  ]
Public Declare Function ceaiVolt_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef fVolt As Double) _
As Long

' ش Ƴα Է ä Է   ȯմϴ.
' [Channel: Ƴα Է ä ȣ, fCurrent: Էµ  ]
Public Declare Function ceaiCurrent_Get _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByRef fCurrent As Double) _
As Long

'****************************************************************************
'*************** START OF ANALOG OUTPUT FUNCTION DECLARATIONS ***************
'****************************************************************************
' ش Ƴα  ä  Digit  մϴ.
' [Channel: Ƴα  ä ȣ, Digit:  Digit ]
Public Declare Function ceaoDigit_Out _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal Digit As Long) _
As Long

' ش Ƴα  ä    մϴ.
' [Channel: Ƴα  ä ȣ, fVolt:   ]
Public Declare Function ceaoVolt_Out _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal fVolt As Double) _
As Long

' ش Ƴα  ä    մϴ.
' [Channel: Ƴα  ä ȣ, fCurrent:   ]
Public Declare Function ceaoCurrent_Out _
Lib "ceSDKDLL.dll" _
(ByVal Channel As Long, ByVal fCurrent As Double) _
As Long

'****************************************************************************
'*************** START OF UTILITY FUNCTION DECLARATIONS *********************
'****************************************************************************
' ִ 32Ʈ  ڿ    ġ մϴ.
' [NodeID :   ȣ]
' [NumByte:   (Ʈ )]
' [szText :  ڿ]
Public Declare Function ceutlUserData_Set _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal NumByte As Long, ByRef szText As String) _
As Long

' ִ 32Ʈ  ڿ    ġ оɴϴ.
' [NodeID :   ȣ]
' [NumByte: о  (Ʈ )]
' [szText : о ڿ ȯ]
Public Declare Function ceutlUserData_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef NumByte As Long, ByRef szText As String) _
As Long

'   忡    մϴ.
' [NodeID :   ȣ]
' [Version:  ]
Public Declare Function ceutlUserVersion_Set _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal Version As Long) _
As Long

'       оɴϴ.
' [NodeID :   ȣ]
' [Version: ϵ  ȯ]
Public Declare Function ceutlUserVersion_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef pVersion As Long) _
As Long

'    ߿  оɴϴ.
' [NodeID :   ȣ]
' [Version: ϵ ߿  ȯ]
Public Declare Function ceutlNodeVersion_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef pVersion As Long) _
As Long

'  ̺귯  ɴϴ.    4Ʈ ּҿ  2Ʈ  Ҵմϴ.  ڸ  4ڸԴϴ.
' ̺귯     ϴ.
' [pVersionMS :  Ʈ   ȯ]
' [pVersionLS :  Ʈ   ȯ]
' printf("Dynamic Link Library Version = [%d].[%d].[%d].[%d]"
'       _X(pVersionMS >> 16 & 0xFF)
'       _X(pVersionMS >> 0 & 0xFF)
'       _X(pVersionLS >> 16 & 0xFF)
'       _X(pVersionLS >> 0 & 0xFF));
Public Declare Function ceutlLibVersion_Get _
Lib "ceSDKDLL.dll" _
(ByRef pVersionMS As Long, ByRef pVersionLS As Long) _
As Long

'   ޼ óմϴ.
Public Declare Function ceutlPumpSingleMessage _
Lib "ceSDKDLL.dll" _
() _
As Long

'   ޼ óմϴ. ڷ  nTimeout   ð  ޼ óϰ ˴ϴ.
'  nTimeout CN_INFINITE  ϰԵǸ,   ޼ ó  ȯ˴ϴ.
' nTimeout   ms Դϴ
' [nTimeout :  ð  ޼ óմϴ.]
Public Declare Function ceutlPumpMultiMessage _
Lib "ceSDKDLL.dll" _
(ByVal nTimeout As Long) _
As Long

'   ȭ ϱ   īƮ ȯ
' [NodeID :  , pSyncCount :    īƮ ȯ]
Public Declare Function ceutlSyncCount_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef pSyncCount As Long) _
As Long

'   ȭ ϱ  I/O ޼  īƮ ȯ
' [NodeID :  , pSyncCount :    īƮ ȯ]
Public Declare Function ceutlIOSyncCount_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef pSyncCount As Long) _
As Long

'   α׷  ȭ  óմϴ.
'  ɵ   ֱ ޼ ȭ  մϴ.
' [NodeID :  , IsBlocking : ⸦  ϴ   ޼ Blocking ]
Public Declare Function ceutlSyncWait _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByVal IsBlocking As Long) _
As Long

' 忡 ֱ ޼  Ÿ  ȯմϴ.
' [NodeID :  , pTimeStamp :   Ÿ ]
Public Declare Function ceutlTimeStamp_Get _
Lib "ceSDKDLL.dll" _
(ByVal NodeID As Long, ByRef pTimeStamp As Long) _
As Long

