//*******************************************************************************
//* [ SxMove.Pas ]
//* SxMove Example file for API fuctions in CeSDK library
//* - Update Data: 2008/03/07
//* - Provider: COMIZOA Co., Ltd.
//* - Phone: +82-42-936-6500~6
//* - Fax  : +82-42-936-6507
//* - URL  : http://www.comizoa.co.kr,  http://www.comizoa.com
//********************************************************************************

unit SxMove;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Label4: TLabel;
    StaticText1: TStaticText;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    ComboBox1: TComboBox;
    btnNegative: TBitBtn;
    btnPositive: TBitBtn;
    btnStop: TBitBtn;
    GroupBox2: TGroupBox;
    lbl: TLabel;
    lblCmdPos: TLabel;
    Timer1: TTimer;
    Label5: TLabel;
    lblFeedPos: TLabel;
    chkBlocking: TCheckBox;
    Label7: TLabel;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    procedure Timer1Timer(Sender: TObject);

    procedure btnPositiveClick(Sender: TObject);
    procedure btnNegativeClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);

    function GetActiveChannel() : LongInt;
    function GetDistance() : LongInt;
    function GetBlocking() : LongInt;


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

/////////////////////////////////////////////////////////////
// COMZIOA SDK Library   ̽  մϴ.
uses ceSDK;
/////////////////////////////////////////////////////////////

{$R *.dfm}


// * Prototype : procedure TForm1.FormCreate(Sender: TObject);
// *
// * Description :
// *
// *  Լ  ɶ ̺Ʈ  ҷ , ġ εϴ ԼԴϴ.
// *
// * شϴ   Combo Box  ߰ϸ,  ߻,  ڵ Ͽ,
// * ޽ ȭ鿡 Ÿϴ.
// *
procedure TForm1.FormCreate(Sender: TObject);
var
  m_nAxis : LongInt;
  m_nResult : LongInt;
  m_nNumNode : LongInt; // ĵ  
  m_nIsSearched : LongInt;
	i : integer;
begin

	if ( ceGnLoad() <> ceERR_NONE ) then
	begin
    Application.Terminate;
	end;

  m_nResult := ceGnIsSearchedDevice (@m_nIsSearched);
  if ( m_nIsSearched <> CE_TRUE ) then
  begin
    ceGnSearchDevice (10, 10*100, CE_FALSE, @m_nNumNode); // 带 Scan մϴ. ִ   10,  100ms  timeout  .
  end;
  else
  begin
    ceGnReSearchDevice (10, 10*100, CE_FALSE, @m_nNumNode); // 带 ٽ Scan մϴ.(Refresh)
  end;

  ceGnTotalMotionChannel ( @m_nAxis );
	for i := 0 to m_nAxis - 1 do
	begin
		ComboBox1.Items.Add('Axis ' + IntToStr(i));
	end;

	ComboBox1.ItemIndex := 0;


end;

// *
// * Prototype : procedure TForm1.OnTimer([IN] Sender: TObject);
// * 
// * Description :
// *
// *  Լ Ÿ̸ ̺Ʈ ؼ ҷ, ȭ    ǥմϴ. 
// *
// *
procedure TForm1.Timer1Timer(Sender: TObject);
var
	fPosition : Double;
begin
	cemStPosition_Get(GetActiveChannel(), 0,  @fPosition);
	lblCmdPos.Caption := FloatToStr(fPosition);
	cemStPosition_Get(GetActiveChannel(), 0,  @fPosition);
	lblFeedPos.Caption := FloatToStr(fPosition);
end;


// *
// * Prototype : procedure TForm1.btnPositiveClick([IN] Sender: TObject);
// *
// * Description :
// *
// *  Լ ư ̺Ʈ  +   Ÿŭ ̵ϴ ԼԴϴ.
// *
// *
procedure TForm1.btnPositiveClick(Sender: TObject);
begin
	////////////////////////////////////////////////////////////////////////////////////////
	//  COMIZOA     Լ մϴ.

	// )  ޽ ° ġ ⸦  ޽  Է ġ  

	//  :  Լ   ġ ޽  , ġ ⸦  ɵ ġ
	// 		  ̼ Ŀ Լ ȯ˴ϴ.

	// cemSxMove [ǥ]
	// cemSxMoveTo [ǥ]

	// )  ޽   ٷ Ḧ  Լ

	//  :  Լ   ġ ޽  ,
	// 		  Լ ȯ˴ϴ.
	//	       Լ    ڰ  ġ ⸦   Ḧ Ǵ  ִ Լ
	//		  cmmSxIsDone Ȥ cmmSxWaitDone Լ ֽϴ.

	// cemSxMoveStart [ǥ]
	// cemSxMoveToStart [ǥ]: MoveTo   ̸ To   Լ ǥ ̼ Լ ǹմϴ.
	// * ̼Լ -Start   Լ Լ  ÿ ٷ Լ ȯ ϸ ٸ    ֽϴ ( ޽ Non-blocking )
	// * ̼Լ -Start    Լ(: cemSxMove, cemSxMoveTo )  ο   Ϸɶ blocking  մϴ. ,   Ϸ Լ  ϵ˴ϴ.
	// *	 Լ  ϷǱ  ޽   ϴ.
	////////////////////////////////////////////////////////////////////////////////////////

    // ӵ ؼӵ    մϴ.
    // ⼭  ӵ cemCfgSpeedPattern_Set Լ   ӵ ǹϸ,
    // Ʒ cemSxSpeedRatio_Set Լ (Single Axis)   ӵ
    //  ӵ  Percent(%)  Է ޾ ϴ ԼԴϴ.
    cemSxSpeedRatio_Set(
        GetActiveChannel(),
        2,    // S-CURVE MODE.
        100,  // Work Speed (%)
        100,  // Accel (%)
        100   // Decel (%)
        );

    //   ̵  մϴ. ̵ ư Ȱȭմϴ.
    btnPositive.Enabled := False;
    btnNegative.Enabled := False;

  cemSxMoveStart
	(
		GetActiveChannel(),
		GetDistance(),
		);

    //   ̵Ϸ ̵ ư Ȱȭմϴ.
    btnPositive.Enabled := True;
    btnNegative.Enabled := True;
end;

// *
// * Prototype : procedure TForm1.btnNegativeClick([IN] Sender: TObject);
// *
// * Description :
// *
// *  Լ ư ̺Ʈ  -   Ÿŭ [ǥ] ̵ϴ ԼԴϴ.
// *
// *
procedure TForm1.btnNegativeClick(Sender: TObject);
begin
    cemSxSpeedRatio_Set(
        GetActiveChannel(),
        2,    // S-CURVE MODE.
        100,  // Work Speed (%)
        100,  // Accel (%)
        100   // Decel (%)
        );

    //   ̵  մϴ. ̵ ư Ȱȭմϴ.
    btnPositive.Enabled := False;
    btnNegative.Enabled := False;


	cemSxMoveStart
	(
		GetActiveChannel(),
		- GetDistance(),              // '-' ڿ 
	);

    //   ̵Ϸ ̵ ư Ȱȭմϴ.
    btnPositive.Enabled := True;
    btnNegative.Enabled := True;
end;



// *
// * Prototype : procedure TForm1.btnStopClick([IN] Sender: TObject);
// *
// * Description :
// *
// *  Լ ư ̺Ʈ    ϴ ԼԴϴ.
// *
// *
procedure TForm1.btnStopClick(Sender: TObject);
begin

    // Լ ڿ ؼ  帮ڽϴ.

    //  Լ  cemSxStop([TargetAxis], [IsWaitComplete], [IsBlocking])
    // Դϴ.

    // TargetAxis :     մϴ.
    // IsWaitComplete :       Լ ȯ  ʽϴ.
    // IsBlocking : Լ ۽  ޽ ó θ Ǵմϴ.
    //              CE_FALSE ÿ  ޽ Լ ο óְ ˴ϴ.
    //               ڼ  ޴ ֽñ ٶϴ.
	cemSxStop(GetActiveChannel(),CE_TRUE,GetBlocking());
end;




// *
// * Prototype : function TForm1.GetActiveChannel()
// *
// * Returntype : LongInt
// *
// * Description :
// *
// *  Ȱȭ Ǿ ִ  ȣ ȯմϴ.
// *
// *

function TForm1.GetActiveChannel() : LongInt;
begin
	Result := ComboBox1.ItemIndex;
end;

// *
// * Prototype : function TForm1.GetDistance()
// * 
// * Returntype : LongInt 
// *
// * Description :
// *
// *  ǥ ̵Ÿ ȯմϴ. 
// *
// *

function TForm1.GetDistance() : LongInt;
begin
	Result := StrToInt(Edit1.Text);
end;

// *
// * Prototype : function TForm1.GetBlocking()
// * 
// * Returntype : LongInt 
// *
// * Description :
// *
// *  Ȱȭ Blocking   θ ȯմϴ.
// *
// *

function TForm1.GetBlocking() : LongInt;
begin

	if ( chkBlocking.Checked = True ) then Result := CE_TRUE
else Result := CE_FALSE;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
    MotStates : LongInt;
begin

    // Լ ڿ ؼ  帮ڽϴ.

    //  Լ  cemSxStop([TargetAxis], [IsWaitComplete], [IsBlocking])
    // Դϴ.

    // TargetAxis :     մϴ.
    // IsWaitComplete :       Լ ȯ  ʽϴ.
    // IsBlocking : Լ ۽  ޽ ó θ Ǵմϴ.
    //              cmFALSE ÿ  ޽ Լ ο óְ ˴ϴ.
    //               ڼ  ޴ ֽñ ٶϴ.

    cemStReadMotionState(GetActiveChannel(), @MotStates);

    if cemMST_STOP <> MotStates then
    begin
    	cemSxStop(GetActiveChannel(),CE_TRUE,GetBlocking());
    end;

    ceGnUnload;
end;

end.


