// HomeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Home.h"
#include "HomeDlg.h"
#include "..\Common\ceSDK.h"
#include "HomeSetup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define CMM_MAX_STR_LEN_AXIS_TITLE 50

#define EXPECTED_NODECOUNT	10
#define TIMEOUT	(10*100) //  ϳ 100ms

long g_nErrCode;

void CHomeDlg::ShowCeSdkError(int nErrCode)
{
	CString sMsg;
	sMsg.Format("ceSDK error has been occured!\nerror code = %d", nErrCode);
	MessageBox(sMsg, "cnSDK Error", MB_OK|MB_ICONERROR);
}

/////////////////////////////////////////////////////////////////////////////
// CHomeDlg dialog

CHomeDlg::CHomeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHomeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHomeDlg)
	m_nDirection = 0;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHomeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHomeDlg)
	DDX_Control(pDX, IDC_cmbAxisSel2, m_cmbAxisSel);
	DDX_Radio(pDX, IDC_rdoDir, m_nDirection);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHomeDlg, CDialog)
	//{{AFX_MSG_MAP(CHomeDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_btnResetPos, OnResetPos)
	ON_BN_CLICKED(IDC_btnGoHome, OnGoHome)
	ON_BN_CLICKED(IDC_btnStop, OnStop)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_btnHomeConfig, OnHomeConfig)
	ON_BN_CLICKED(IDC_BTN_VIEWSTATEMON, OnBtnViewstatemon)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHomeDlg message handlers

BOOL CHomeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Load CMMSDK(DLL) Library //
	if(!ceLoadDll()){
		MessageBox("Can't load CE-SDK Library(DLL)", "Error", MB_OK | MB_ICONERROR);
		return TRUE;
	}

	// set debug mode enable
	//cnGnDebugMode(2, NULL);

	// Load Motion & DIO devices //
	long nNumNodes = 0;
	int i;
		
	//̽ ε մϴ.
	g_nErrCode = ceGnLoad();

	if( g_nErrCode != ceERR_NONE ) 
	{
		ShowCeSdkError(g_nErrCode);
		return FALSE;
	}		

	long nIsSearchedDev = 0;

	//̹ ˻  Ȯմϴ.
	ceGnIsSearchedDevice( &nIsSearchedDev );

	if ( nIsSearchedDev == CE_FALSE )
	{
		//带 ˻մϴ.
		if((g_nErrCode = ceGnSearchDevice(EXPECTED_NODECOUNT, TIMEOUT, FALSE, &nNumNodes)) < 0) {
			ShowCeSdkError(g_nErrCode);
			return FALSE;
		}		
	}
	else
	{
		//带 ˻մϴ.
		if((g_nErrCode = ceGnReSearchDevice(EXPECTED_NODECOUNT, TIMEOUT, FALSE, &nNumNodes)) < 0) {
			ShowCeSdkError(g_nErrCode);
			return FALSE;
		}		
	}

	ceGnTotalMotionChannel( &m_nNumAxes );

	//ConfigMotion();
	m_pStateMonDlg = new CStateMonitorDlg(this);
	VERIFY(m_pStateMonDlg->Create(IDD_STATEMONITOR_DIALOG, this));

	////////////////////////////////////////////////////////////////////////////////////
	// ༳ ޺ڽ ฮƮ äֽϴ. 
	char szAxisTitle[CMM_MAX_STR_LEN_AXIS_TITLE];
	m_cmbAxisSel.ResetContent(); // Clear combobox
	for(i=0; i<m_nNumAxes; i++){
		sprintf(szAxisTitle, "Axis %d", i);
		m_cmbAxisSel.AddString(szAxisTitle);
	}
	m_cmbAxisSel.SetCurSel(0);

	SetTimer(0, 100, NULL); 

	//  带 ʱȭ մϴ.
	//cemHomeConfig_Set(nAxis, 0, m_nDirection, 0, 100, 0);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHomeDlg::ConfigMotion()
{
	for(int i=0; i<m_nNumAxes; i++)
	{
		cemCfgMioProperty_Set(i, cemMPID_ALM_LOGIC, cemLOGIC_A);
		cemCfgMioProperty_Set(i, cemMPID_EL_LOGIC, cemLOGIC_A);
		cemCfgInMode_Set(i, cemIMODE_AB4X, false);
		cemCfgOutMode_Set(i, cemOMODE_CWCCW0);
	}
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHomeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CHomeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


/***********************************************************************
* OnResetPos() : Position "Reset" ư ݹԼ. Command & Feedback 
* position 0 Ѵ.
***********************************************************************/
void CHomeDlg::OnResetPos() 
{
	int nAxis = m_cmbAxisSel.GetCurSel();
	cemStPosition_Set(nAxis, cemCNT_COMM, 0.0);
	cemStPosition_Set(nAxis, cemCNT_FEED, 0.0);
}

/***********************************************************************
* OnGoHome() : "GO HOME" ư ݹԼ.  ࿡ Ͽ ͸
* Ѵ.
***********************************************************************/
void CHomeDlg::OnGoHome() 
{
	UpdateData();
	int nAxis = m_cmbAxisSel.GetCurSel();

	//   //
	if((g_nErrCode=cemHomeMoveStart( nAxis )) != ceERR_NONE){
		ShowCeSdkError(g_nErrCode);
	}
	cemHomeWaitDone(nAxis, false);
}

void CHomeDlg::OnStop() 
{
	int nAxis = m_cmbAxisSel.GetCurSel();
	//GetDlgItem(IDC_btnStop)->EnableWindow(FALSE);
	cemSxStop(nAxis, TRUE, FALSE);
	//GetDlgItem(IDC_btnStop)->EnableWindow(TRUE);
}

void CHomeDlg::OnDestroy() 
{
	KillTimer(0);

	if(m_pStateMonDlg)
	{
		delete m_pStateMonDlg;
		m_pStateMonDlg = NULL;
	}
	
	ceGnUnload(); // Unload Device
	ceUnloadDll(); // Unload DLL 	

	CDialog::OnDestroy();
}

void CHomeDlg::OnTimer(UINT nIDEvent) 
{
	int nAxis = m_cmbAxisSel.GetCurSel();
		
	CString sTemp;
	double fTemp;
	cemStPosition_Get(nAxis, cemCNT_COMM, &fTemp); // Read command position
	sTemp.Format("%.16G", fTemp);
	GetDlgItem(IDC_lblPosC)->SetWindowText(sTemp); // Display command position

	cemStPosition_Get(nAxis, cemCNT_FEED, &fTemp); // Read feedback position
	sTemp.Format("%.16G", fTemp);
	GetDlgItem(IDC_lblPosF)->SetWindowText(sTemp); // Display feedback position

	CDialog::OnTimer(nIDEvent);
}

//******************************************************************************************
// OnHomeConfig(): "Change Home Config" ư ̺Ʈ ڵ鷯.   coding 
// ȯ ϴ  ϱ  ̴.  ȯ漳 ڵ ϴ 
//  CHomeSetup Ŭ ϸ ȴ. Ϲδ  ȯ漳 CME Ͽ
// ϹǷ ڵ  ȯ漳   ʿ .
//******************************************************************************************
void CHomeDlg::OnHomeConfig() 
{
	CHomeSetup HomeSetupDlg(this);

	HomeSetupDlg.SetAxis(m_cmbAxisSel.GetCurSel());
	HomeSetupDlg.DoModal();
}

void CHomeDlg::OnBtnViewstatemon() 
{
	if(m_pStateMonDlg)
	{
		m_pStateMonDlg->ShowWindow(SW_SHOW);
	}
}
