// HomeSetup.cpp : implementation file
//

#include "stdafx.h"
#include "Home.h"
#include "HomeSetup.h"
#include "..\Common\ceSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHomeSetup dialog


CHomeSetup::CHomeSetup(CWnd* pParent /*=NULL*/)
	: CDialog(CHomeSetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHomeSetup)
	m_bErcOut = FALSE;
	m_nEzLogic = -1;
	m_nHomeMode = -1;
	m_nDirection = 0;
	m_nOrgLogic = -1;
	m_nSpeedMode = -1;
	m_fDec = 0.0;
	m_fAcc = 0.0;
	m_fEscDist = 0.0;
	m_fOffsetDist = 0.0;
	m_fRvsSpeed = 0.0;
	m_fWorkSpeed = 0.0;
	m_nEzCount = 0;
	//}}AFX_DATA_INIT
}


void CHomeSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHomeSetup)
	DDX_Check(pDX, IDC_chkErcOut, m_bErcOut);
	DDX_CBIndex(pDX, IDC_cmbEzLogic, m_nEzLogic);
	DDX_CBIndex(pDX, IDC_cmbHomeMode, m_nHomeMode);
	DDX_CBIndex(pDX, IDC_cmbOrgLogic, m_nOrgLogic);
	DDX_CBIndex(pDX, IDC_cmbSpeedMode, m_nSpeedMode);
	DDX_Text(pDX, IDC_edDec, m_fDec);
	DDX_Text(pDX, IDC_edtAcc, m_fAcc);
	DDX_Text(pDX, IDC_edtEscDist, m_fEscDist);
	DDX_Text(pDX, IDC_edtOffset, m_fOffsetDist);
	DDX_Text(pDX, IDC_edtRvsSpd, m_fRvsSpeed);
	DDX_Text(pDX, IDC_edtWorkSpeed, m_fWorkSpeed);
	DDX_Text(pDX, IDC_edtEzCount, m_nEzCount);
	DDV_MinMaxLong(pDX, m_nEzCount, 0, 999999);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHomeSetup, CDialog)
	//{{AFX_MSG_MAP(CHomeSetup)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHomeSetup message handlers

BOOL CHomeSetup::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	long dwTemp1;
	cemHomeConfig_Get(m_nAxis, (long *)&m_nHomeMode, (long *)&m_nDirection, &m_nEzCount, &m_fEscDist, &m_fOffsetDist);
	cemCfgMioProperty_Get(m_nAxis, cemMPID_ORG_LOGIC, (long *)&m_nOrgLogic);
	cemCfgMioProperty_Get(m_nAxis, cemMPID_EZ_LOGIC, (long *)&m_nEzLogic);
	cemCfgMioProperty_Get(m_nAxis, cemMPID_ERC_OUT, &dwTemp1);  m_bErcOut = dwTemp1;
	cemHomeSpeedPattern_Get(m_nAxis, (long *)&m_nSpeedMode, &m_fWorkSpeed, &m_fAcc, &m_fDec, &m_fRvsSpeed);
	
	UpdateData(FALSE); // ȭ Ʈ 
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CHomeSetup::OnOK() 
{
	UpdateData();
	cemHomeConfig_Set(m_nAxis, m_nHomeMode, m_nDirection, m_nEzCount, m_fEscDist, m_fOffsetDist);
	cemCfgMioProperty_Set(m_nAxis, cemMPID_ORG_LOGIC, m_nOrgLogic);
	cemCfgMioProperty_Set(m_nAxis, cemMPID_EZ_LOGIC, m_nEzLogic);
	cemCfgMioProperty_Set(m_nAxis, cemMPID_ERC_OUT, m_bErcOut);  
	cemHomeSpeedPattern_Set(m_nAxis, m_nSpeedMode, m_fWorkSpeed, m_fAcc, m_fDec, m_fRvsSpeed);
	
	CDialog::OnOK();
}
