// ManualPulsarDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ManualPulsar.h"
#include "ManualPulsarDlg.h"
#include "..\Common\ceSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define EXPECTED_NODECOUNT	10
#define TIMEOUT	(10*100) //  ϳ 100ms

long g_nErrCode;

void CManualPulsarDlg::ShowCeSdkError(int nErrCode)
{
	CString sMsg;
	sMsg.Format("ceSDK error has been occured!\nerror code = %d", nErrCode);
	MessageBox(sMsg, "cnSDK Error", MB_OK|MB_ICONERROR);
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManualPulsarDlg dialog

CManualPulsarDlg::CManualPulsarDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CManualPulsarDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CManualPulsarDlg)
	m_uGainFactor = 0;
	m_uDivFactor = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pStateMonDlg = NULL;
}

void CManualPulsarDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CManualPulsarDlg)
	DDX_Text(pDX, IDC_EDIT_GAINFACTOR, m_uGainFactor);
	DDX_Text(pDX, IDC_EDIT_DIVFACTOR, m_uDivFactor);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CManualPulsarDlg, CDialog)
	//{{AFX_MSG_MAP(CManualPulsarDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_MOVE, OnBtnMove)
	ON_BN_CLICKED(IDC_BTN_STOP, OnBtnStop)
	ON_CBN_SELCHANGE(IDC_CMB_OPMODE, OnSelchangeCmbOpmode)
	ON_BN_CLICKED(IDC_BTN_STOP_AXIS0, OnBtnStopAxis0)
	ON_BN_CLICKED(IDC_BTN_STOP_AXIS1, OnBtnStopAxis1)
	ON_BN_CLICKED(IDC_BTN_STOP_AXIS2, OnBtnStopAxis2)
	ON_BN_CLICKED(IDC_BTN_STOP_AXIS3, OnBtnStopAxis3)
	ON_BN_CLICKED(IDC_BTN_STOP_AXIS4, OnBtnStopAxis4)
	ON_BN_CLICKED(IDC_BTN_STOP_AXIS5, OnBtnStopAxis5)
	ON_BN_CLICKED(IDC_BTN_VIEWSTATEMON, OnBtnViewstatemon)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManualPulsarDlg message handlers

BOOL CManualPulsarDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Load CMMSDK(DLL) Library //
	if(!ceLoadDll()){
		MessageBox("Can't load CE-SDK Library(DLL)", "Error", MB_OK | MB_ICONERROR);
		return TRUE;
	}

	//set debug mode enable
	//ceGnDebugMode(2, NULL);

	// Load Motion & DIO devices //
	long nNumNodes;
	int i;
		
	//̽ ε մϴ.
	g_nErrCode = ceGnLoad();

	if( g_nErrCode != ceERR_NONE ) 
	{
		ShowCeSdkError(g_nErrCode);
		return FALSE;
	}		

	long nIsSearchedDev = 0;

	//̹ ˻  Ȯմϴ.
	ceGnIsSearchedDevice( &nIsSearchedDev );

	if ( nIsSearchedDev == CE_FALSE )
	{
		//带 ˻մϴ.
		if((g_nErrCode = ceGnSearchDevice(EXPECTED_NODECOUNT, TIMEOUT, FALSE, &nNumNodes)) < 0) {
			ShowCeSdkError(g_nErrCode);
			return FALSE;
		}		
	}
	else
	{
		//带 ˻մϴ.
		if((g_nErrCode = ceGnReSearchDevice(EXPECTED_NODECOUNT, TIMEOUT, FALSE, &nNumNodes)) < 0) {
			ShowCeSdkError(g_nErrCode);
			return FALSE;
		}		
	}

	ceGnTotalMotionChannel( &m_nNumAxes );
	
	for(i=0; i<m_nNumAxes; i++)
	{
		if(i>=6)
			break;	//   6 մϴ.

		GetDlgItem(IDC_CHK_AXIS0 + i)->EnableWindow();
	}

	m_uGainFactor = 32;
	m_uDivFactor = 2048;

	//ConfigMotion();
	m_pStateMonDlg = new CStateMonitorDlg(this);
	VERIFY(m_pStateMonDlg->Create(IDD_STATEMONITOR_DIALOG, this));

	((CComboBox *)GetDlgItem(IDC_CMB_OPMODE))->SetCurSel(1);	// Operation mode  Velocity Move  
	OnSelchangeCmbOpmode();

	((CComboBox *)GetDlgItem(IDC_CMB_INMODE))->SetCurSel(3);	// input mode  CW/CCW  
	((CComboBox *)GetDlgItem(IDC_CMB_HOMETYPE))->SetCurSel(0);	// Home type  command  
	GetDlgItem(IDC_EDIT_POSDIST)->SetWindowText("1000");

	// Set timer to display current command position //
	SetTimer(0, 100, NULL); 

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CManualPulsarDlg::ConfigMotion()
{
	for(int i=0; i<m_nNumAxes; i++)
	{
		cemCfgMioProperty_Set(i, cemMPID_ALM_LOGIC, cemLOGIC_A);
		cemCfgMioProperty_Set(i, cemMPID_EL_LOGIC, cemLOGIC_A);
		cemCfgInMode_Set(i, cemIMODE_AB4X, false);
		cemCfgOutMode_Set(i, cemOMODE_CWCCW0);
	}
}


void CManualPulsarDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CManualPulsarDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CManualPulsarDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

CString CManualPulsarDlg::GetMstString(DWORD dwMst)
{
	switch (dwMst)
	{
	case cemMST_STOP:
		return "Stop";
	case cemMST_WAIT_DR:
		return "Wait DR";
	case cemMST_WAIT_STA:
		return "Wait STA";
	case cemMST_WAIT_INSYNC:
		return "Wait INSYNC";
	case cemMST_WAIT_OTHER:
		return "Wait OTHER";
	case cemMST_WAIT_ERC:
		return "Wait ERC";
	case cemMST_WAIT_DIR:
		return "Wait DIR";
	case cemMST_WAIT_PLSR:
		return "Wait PLSR";
	case cemMST_IN_RVSSPD:
		return "Wait RVSSPD";
	case cemMST_IN_INISPD:
		return "IniSpeed";
	case cemMST_IN_ACC:
		return "In Acceleration";
	case cemMST_IN_WORKSPD:
		return "In Workspeed";
	case cemMST_IN_DEC:
		return "In Deceleration";
	case cemMST_WAIT_INP:
		return "Wait INP";
	}

	return "Unknown";
}

void CManualPulsarDlg::OnTimer(UINT nIDEvent) 
{
	long nMotStates;
	CString szMotState;
	for(int i=0; i<m_nNumAxes; i++)
	{
		cemStReadMotionState(i, &nMotStates);
		szMotState = GetMstString(nMotStates); // convert motion state code to string
		GetDlgItem(IDC_EDIT_MOTSTATUS0 + i)->SetWindowText(szMotState);
	}

	CDialog::OnTimer(nIDEvent);
}

void CManualPulsarDlg::OnDestroy() 
{
	KillTimer(0);

	if(m_pStateMonDlg != NULL)
	{
		delete m_pStateMonDlg;
		m_pStateMonDlg = NULL;
	}

	OnBtnStop();

	ceGnUnload(); // Unload Device
	ceUnloadDll(); // Unload DLL	

	CDialog::OnDestroy();
}

void CManualPulsarDlg::OnBtnMove() 
{
	UpdateData();

	int i, nInMode, nIsInverse;
	int nSelAxisCnt = 0;
	CString sErr;

	nInMode = ((CComboBox *)GetDlgItem(IDC_CMB_INMODE))->GetCurSel();
	nIsInverse = ((CButton *)GetDlgItem(IDC_CHK_INVERSE))->GetCheck();

	// pulsar config   մϴ.
	nSelAxisCnt = 0;
	for(i=0; i<m_nNumAxes; i++)
	{
		if ( ((CButton *)GetDlgItem(IDC_CHK_AXIS0 + i))->GetCheck() )
		{
			if(m_uGainFactor < 1 || m_uGainFactor > 32)
				m_uGainFactor = 32;
			if(m_uDivFactor < 1 || m_uDivFactor > 2048)
				m_uDivFactor = 2048;

			UpdateData(FALSE);

			// input mode 
			if(cemPlsrInMode_Set(i, nInMode, nIsInverse) != ceERR_NONE)
			{
				sErr.Format("Axis %d  input mode   ߻", i);
				AfxMessageBox(sErr);
				return;
			}

			// gain & div factor 
			if(cemPlsrGain_Set(i, m_uGainFactor, m_uDivFactor) != ceERR_NONE)
			{
				sErr.Format("Axis %d  gain/div factor   ߻", i);
				AfxMessageBox(sErr);
				return;
			}

			nSelAxisCnt++;
		}
	}

	if(nSelAxisCnt < 1)
	{
		AfxMessageBox("ּ ϳ Axis   Ͻʽÿ");
		return;
	}

	DOUBLE fDist = 0.0;
	CString strDist;
	// pulsar config  ϷǸ operation mode   ش move  մϴ.
	int nOpMode = ((CComboBox *)GetDlgItem(IDC_CMB_OPMODE))->GetCurSel();
	switch (nOpMode)
	{
		case 0:	// Home Move
		{
			for(i=0; i<m_nNumAxes; i++)
			{
				if ( ((CButton *)GetDlgItem(IDC_CHK_AXIS0 + i))->GetCheck() )
				{
					cemCfgSpeedPattern_Set(i, 0, 2000, 10000, 10000);
					cemPlsrHomeMoveStart(i, 4);	// Home Type    (0 ~ 12)
				}
			}
			break;
		}
		case 1:	// Velocity Move
		{
			for(i=0; i<m_nNumAxes; i++)
			{
				if ( ((CButton *)GetDlgItem(IDC_CHK_AXIS0 + i))->GetCheck() )
				{
					cemCfgSpeedPattern_Set(i, 0, 2000, 10000, 10000);
					cemPlsrVMoveStart(i);
				}
			}
			break;
		}

		case 2:
			{
			for(i=0; i<m_nNumAxes; i++)
			{
				if ( ((CButton *)GetDlgItem(IDC_CHK_AXIS0 + i))->GetCheck() )
				{
					GetDlgItem(IDC_EDIT_POSDIST)->GetWindowText(strDist);
					fDist = atof( strDist.GetBuffer(strDist.GetLength()) );
					cemCfgSpeedPattern_Set(i, 0, 2000, 10000, 10000);
					cemPlsrMoveStart( i, fDist );
				}
			}
			break;
		}
		case 3:
			{
			for(i=0; i<m_nNumAxes; i++)
			{
				if ( ((CButton *)GetDlgItem(IDC_CHK_AXIS0 + i))->GetCheck() )
				{
					GetDlgItem(IDC_EDIT_POSDIST)->GetWindowText(strDist);
					fDist = atof( strDist.GetBuffer(strDist.GetLength()) );
					cemCfgSpeedPattern_Set(i, 0, 2000, 10000, 10000);
					cemPlsrMoveToStart( i, fDist );
				}
			}
			break;
		}
	}

	GetDlgItem(IDC_BTN_MOVE)->EnableWindow(FALSE);	
}

void CManualPulsarDlg::OnBtnStop() 
{
	for(int i=0; i<m_nNumAxes; i++)
	{
		cemSxStopEmg(i);
	}

	GetDlgItem(IDC_BTN_MOVE)->EnableWindow();
}

void CManualPulsarDlg::OnSelchangeCmbOpmode() 
{
	int nOpMode = ((CComboBox *)GetDlgItem(IDC_CMB_OPMODE))->GetCurSel();
	switch (nOpMode)
	{
	case 0:	// Home Move
		GetDlgItem(IDC_LBL_HOMETYPE)->EnableWindow(TRUE);
		GetDlgItem(IDC_CMB_HOMETYPE)->EnableWindow(TRUE);
		GetDlgItem(IDC_LBL_POSDIST)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_POSDIST)->EnableWindow(FALSE);

		break;
	case 1:	// Velocity Move
		GetDlgItem(IDC_LBL_HOMETYPE)->EnableWindow(FALSE);
		GetDlgItem(IDC_CMB_HOMETYPE)->EnableWindow(FALSE);
		GetDlgItem(IDC_LBL_POSDIST)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_POSDIST)->EnableWindow(FALSE);
		break;
	case 2:	// Relative In-Position
		GetDlgItem(IDC_LBL_HOMETYPE)->EnableWindow(FALSE);
		GetDlgItem(IDC_CMB_HOMETYPE)->EnableWindow(FALSE);
		GetDlgItem(IDC_LBL_POSDIST)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_POSDIST)->EnableWindow(TRUE);
		GetDlgItem(IDC_LBL_POSDIST)->SetWindowText("Distance");
		break;
	case 3: // Absolute In-Position
		GetDlgItem(IDC_LBL_HOMETYPE)->EnableWindow(FALSE);
		GetDlgItem(IDC_CMB_HOMETYPE)->EnableWindow(FALSE);
		GetDlgItem(IDC_LBL_POSDIST)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_POSDIST)->EnableWindow(TRUE);
		GetDlgItem(IDC_LBL_POSDIST)->SetWindowText("Position");
		break;
	}
}

void CManualPulsarDlg::OnBtnStopAxis0() 
{
	cemSxStopEmg(0);	
}

void CManualPulsarDlg::OnBtnStopAxis1() 
{
	cemSxStopEmg(1);
}

void CManualPulsarDlg::OnBtnStopAxis2() 
{
	cemSxStopEmg(2);
}

void CManualPulsarDlg::OnBtnStopAxis3() 
{
	cemSxStopEmg(3);	
}

void CManualPulsarDlg::OnBtnStopAxis4() 
{
	cemSxStopEmg(4);
}

void CManualPulsarDlg::OnBtnStopAxis5() 
{
	cemSxStopEmg(5);
}

void CManualPulsarDlg::OnBtnViewstatemon() 
{
	if(m_pStateMonDlg != NULL)
		m_pStateMonDlg->ShowWindow(SW_SHOW);
}
