// SxMotion_2VelDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SxMotion_2Vel.h"
#include "SxMotion_2VelDlg.h"
#include "..\Common\ceSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

enum {JOGMODE_REL, JOGMODE_ABS}TJogModeID;
enum _TLedID{LED_ALM, LED_ELN, LED_ELP, LED_ORG, LED_INP, LED_RDY, LED_LTC, LED_SD, LED_STA, LED_STP, LED_ERC};

#define EXPECTED_NODECOUNT	10
#define TIMEOUT	(10*100) //  ϳ 100ms

long g_nErrCode;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSxMotion_2VelDlg dialog

void CSxMotion_2VelDlg::ShowCeSdkError(int nErrCode)
{
	CString sMsg;
	sMsg.Format("ceSDK error has been occured!\nerror code = %d", nErrCode);
	MessageBox(sMsg, "ceSDK Error", MB_OK|MB_ICONERROR);
}

CSxMotion_2VelDlg::CSxMotion_2VelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSxMotion_2VelDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSxMotion_2VelDlg)
	m_fDistPos = 20000.0;
	m_sMotState = _T("Stop");
	m_sPosC = _T("0.0");
	m_sPosF = _T("0.0");
	m_sSpeedC = _T("0.0");
	m_sSpeedF = _T("0.0");
	m_nMoveMode = 0;
	m_nSpeedMode = 2;
	m_fAcc = 5000.0;
	m_fDec = 5000.0;
	m_fVini = 0.0;
	m_fVvel1 = 5000.0;
	m_fVvel2 = 7000.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSxMotion_2VelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSxMotion_2VelDlg)
	DDX_Control(pDX, IDC_cmbAxisSel, m_cmbAxisSel);
	DDX_Text(pDX, IDC_EDT_DISTPOS, m_fDistPos);
	DDX_Control(pDX, IDC_COMIGRAPHCTRL1, m_ComiGraph);
	DDX_Text(pDX, IDC_lblMst, m_sMotState);
	DDX_Text(pDX, IDC_lblPosC, m_sPosC);
	DDX_Text(pDX, IDC_lblPosF, m_sPosF);
	DDX_Text(pDX, IDC_lblSpeedC, m_sSpeedC);
	DDX_Text(pDX, IDC_lblSpeedF, m_sSpeedF);
	DDX_Radio(pDX, IDC_RDO_RELMOVEMODE, m_nMoveMode);
	DDX_CBIndex(pDX, IDC_cmbSpeedMode, m_nSpeedMode);
	DDX_Text(pDX, IDC_edtAcc, m_fAcc);
	DDX_Text(pDX, IDC_edtDec, m_fDec);
	DDX_Text(pDX, IDC_edtVini, m_fVini);
	DDX_Text(pDX, IDC_edtVvel1, m_fVvel1);
	DDX_Text(pDX, IDC_edtVvel2, m_fVvel2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSxMotion_2VelDlg, CDialog)
	//{{AFX_MSG_MAP(CSxMotion_2VelDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_btnResetPos, OnbtnResetPos)
	ON_BN_CLICKED(IDC_BTN_MOVE, OnBtnMove)
	ON_BN_CLICKED(IDC_BTN_STOP, OnBtnStop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_chkServoOn, OnchkServoOn)
	ON_BN_CLICKED(IDC_BTN_RESETGRAPH, OnBtnResetgraph)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSxMotion_2VelDlg message handlers

BOOL CSxMotion_2VelDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Load CMMSDK(DLL) Library //
	if(!ceLoadDll()){
		MessageBox("Can't load CE-SDK Library(DLL)", "Error", MB_OK | MB_ICONERROR);
		return TRUE;
	}

	// Set Debug mode enable
	//cnGnDebugMode(2, NULL);

	// Load Motion & DIO devices //
	long nNumNodes;
	int i;

	//̽ ε մϴ.
	g_nErrCode = ceGnLoad();

	if( g_nErrCode != ceERR_NONE ) 
	{
		ShowCeSdkError(g_nErrCode);
		return FALSE;
	}		

	long nIsSearchedDev = 0;

	//̹ ˻  Ȯմϴ.
	ceGnIsSearchedDevice( &nIsSearchedDev );

	if ( nIsSearchedDev == CE_FALSE )
	{
		//带 ˻մϴ.
		if((g_nErrCode = ceGnSearchDevice(EXPECTED_NODECOUNT, TIMEOUT, FALSE, &nNumNodes)) < 0) {
			ShowCeSdkError(g_nErrCode);
			return FALSE;
		}		
	}
	else
	{
		//带 ˻մϴ.
		if((g_nErrCode = ceGnReSearchDevice(EXPECTED_NODECOUNT, TIMEOUT, FALSE, &nNumNodes)) < 0) {
			ShowCeSdkError(g_nErrCode);
			return FALSE;
		}		
	}

	LONG nNodes = 0;
	ceGnTotalNode( &nNodes );

	ceGnTotalMotionChannel( &m_nNumAxes );

	ConfigMotion();

	////////////////////////////////////////////////////////////////////////////////////
	// ༳ ޺ڽ ฮƮ äֽϴ. 
	char szAxisTitle[20];
	m_cmbAxisSel.ResetContent(); // Clear combobox
	for(i=0; i<m_nNumAxes; i++) {
		sprintf(szAxisTitle, "Axis %d", i);
		m_cmbAxisSel.AddString(szAxisTitle);
	}
	m_cmbAxisSel.SetCurSel(0);

	m_LedBmp[0].LoadBitmap(IDB_LedOff);
	m_LedBmp[1].LoadBitmap(IDB_LedBlue);
	m_LedBmp[2].LoadBitmap(IDB_LedRed);

	// Set timer to display current command position //
	SetTimer(0, 100, NULL); 
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSxMotion_2VelDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSxMotion_2VelDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSxMotion_2VelDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


CString CSxMotion_2VelDlg::GetMstString(DWORD dwMst)
{
	switch (dwMst)
	{
	case cemMST_STOP:
		return "Stop";
	case cemMST_WAIT_DR:
		return "Wait DR";
	case cemMST_WAIT_STA:
		return "Wait STA";
	case cemMST_WAIT_INSYNC:
		return "Wait INSYNC";
	case cemMST_WAIT_OTHER:
		return "Wait OTHER";
	case cemMST_WAIT_ERC:
		return "Wait ERC";
	case cemMST_WAIT_DIR:
		return "Wait DIR";
	case cemMST_WAIT_PLSR:
		return "Wait PLSR";
	case cemMST_IN_RVSSPD:
		return "Wait RVSSPD";
	case cemMST_IN_INISPD:
		return "IniSpeed";
	case cemMST_IN_ACC:
		return "In Acceleration";
	case cemMST_IN_WORKSPD:
		return "In Workspeed";
	case cemMST_IN_DEC:
		return "In Deceleration";
	case cemMST_WAIT_INP:
		return "Wait INP";
	}

	CString sTemp;
	sTemp.Format("%d", dwMst);

	return sTemp;
}


UINT g_dwCount = 0;
void CSxMotion_2VelDlg::OnTimer(UINT nIDEvent) 
{
	//UpdateData();
	
	// Motion State Display //
	CString szMotState;
	CString sTemp;
	double fTemp;
	long dwTemp = 0;

	m_nAxis = m_cmbAxisSel.GetCurSel();

	cemStReadMotionState(m_nAxis, &dwTemp); // read motion state code
	szMotState = GetMstString(dwTemp); // convert motion state code to string
	GetDlgItem(IDC_lblMst)->SetWindowText(szMotState); // display motion state string

	// Command position display //
	cemStPosition_Get(m_nAxis, cemCNT_COMM, &fTemp);
	sTemp.Format("%0.16G", fTemp);
	GetDlgItem(IDC_lblPosC)->SetWindowText(sTemp);

	// Feedback position display //
	cemStPosition_Get(m_nAxis, cemCNT_FEED, &fTemp);
	sTemp.Format("%0.16G", fTemp);
	GetDlgItem(IDC_lblPosF)->SetWindowText(sTemp);

	// Command velocity display //
	cemStSpeed_Get(m_nAxis, cemCNT_COMM, &fTemp);
	sTemp.Format("%0.1f", fTemp);
	GetDlgItem(IDC_lblSpeedC)->SetWindowText(sTemp);

	// Feedback velocity display //
	cemStSpeed_Get(m_nAxis, cemCNT_FEED, &fTemp);
	sTemp.Format("%0.1f", fTemp);
	GetDlgItem(IDC_lblSpeedF)->SetWindowText(sTemp);

	//---- MIO Display ----------------------------------------------------//
	cemStReadMioStatuses(m_nAxis, &dwTemp); // Read all MIO states
	SetLedState(LED_ALM, (dwTemp>>cemIOST_ALM) & 0x1); // ALM 
	SetLedState(LED_ELN, (dwTemp>>cemIOST_ELN) & 0x1); // +EL 
	SetLedState(LED_ELP, (dwTemp>>cemIOST_ELP) & 0x1); // -EL
	SetLedState(LED_ORG, (dwTemp>>cemIOST_ORG) & 0x1); // ORG
	SetLedState(LED_INP, (dwTemp>>cemIOST_INP) & 0x1); // INP
	SetLedState(LED_RDY, (dwTemp>>cemIOST_RDY) & 0x1); // RDY 
	SetLedState(LED_LTC, (dwTemp>>cemIOST_LTC) & 0x1); // LTC 
	SetLedState(LED_SD, (dwTemp>>cemIOST_SD) & 0x1); // SD 

	// Servo ON/OFF  ÷ //
	//cemGnServoOn_Get(nAxis, &dwTemp);	// FIXME: cemGnServoOn_Get Լ  ReadMioStatuses Լε on/off  Ȯ .
	CheckDlgButton(IDC_chkServoOn, (dwTemp>>cemIOST_SVON) & 0x1);

	
	// ӵ ׷ //
	double fTime[1], fVel[1];
	cemStSpeed_Get(m_nAxis, cemCNT_COMM, fVel);
	fTime[0] = g_dwCount;
	m_ComiGraph.PlotChart(0, fTime, fVel, 1);
	g_dwCount++;
	m_ComiGraph.UpdatePlot();

	CDialog::OnTimer(nIDEvent);
}

void CSxMotion_2VelDlg::OnResetPlot() 
{
	m_ComiGraph.DeletePlot(-1);
	// ׷  ó ǵ.
	double xmin_old = m_ComiGraph.GetXAxisRangeMin();
	double xmax_old = m_ComiGraph.GetXAxisRangeMax();
	double x_span = xmax_old - xmin_old;
	double xmin_new = 0;
	double xmax_new = xmin_new + x_span;
	// Ʒ SetXAxisRange()Լ bRedraw Ķ͸ TRUE ϿǷ //
	// UpdatePlot ص ȴ.                                         //
	m_ComiGraph.SetXAxisRange(0, xmin_new, xmax_new, TRUE);
	m_ComiGraph.SetChartPause(FALSE); // X   ϸ ڵ PauseǹǷ Pause Ǯش.

	g_dwCount = 0; // X ͸ ϴµ Ǵ Counter ResetϿ ó ٽñ׸ Ѵ.
}

void CSxMotion_2VelDlg::SetLedState(int nLedId, int nLedState)
{
	int nCntrID = IDC_LedALM + nLedId;

	if(nLedState == 0){	// OFF:0, ON:1
		((CStatic *)GetDlgItem(nCntrID))->SetBitmap(m_LedBmp[0]); // OFF LED
	}else{
		switch(nLedId)
		{
		case LED_ALM:
		case LED_ELN:
		case LED_ELP:
			((CStatic *)GetDlgItem(nCntrID))->SetBitmap(m_LedBmp[2]); // Red LED
			break;

		default:
			((CStatic *)GetDlgItem(nCntrID))->SetBitmap(m_LedBmp[1]); // Blue LED
			break;
		}
	}
	
}


void CSxMotion_2VelDlg::ConfigMotion()
{
	for(int i=0; i<m_nNumAxes; i++)
	{
		cemCfgMioProperty_Set(i, cemMPID_ALM_LOGIC, cemLOGIC_A);
		cemCfgMioProperty_Set(i, cemMPID_EL_LOGIC, cemLOGIC_A);
		cemCfgInMode_Set(i, cemIMODE_AB4X, false);
		cemCfgOutMode_Set(i, cemOMODE_CWCCW0);
	}
}

void CSxMotion_2VelDlg::OnbtnResetPos() 
{
	m_nAxis = m_cmbAxisSel.GetCurSel();
	cemStPosition_Set(m_nAxis, cemCNT_COMM, 0.0); // Reset COMMAND Position
	cemStPosition_Set(m_nAxis, cemCNT_FEED, 0.0); // Reset FEEDBACK Position
}

void CSxMotion_2VelDlg::OnBtnMove() 
{
	UpdateData();

	double fYMax = (m_fVvel1 > m_fVvel2) ? m_fVvel1 : m_fVvel2;
	m_ComiGraph.SetYAxisRange(0, 0, fYMax*1.2, TRUE);
	m_ComiGraph.SetChartPause(FALSE); // Y   ϸ ڵ PauseǹǷ Pause Ǯش.

	if(m_nMoveMode == JOGMODE_REL){ // ǥ ̼ ϶
		cemCfgSpeedPattern_Set(m_nAxis, m_nSpeedMode, m_fVvel1, m_fAcc, m_fDec);
		if((g_nErrCode = cemSxMoveStart2V(m_nAxis, m_fDistPos, m_fVvel2)) != ceERR_NONE){ 
			//ShowCnSdkError(g_nErrCode);
		}
		cemSxWaitDone(m_nAxis, false);
	}else{ //  ǥ ̼ ϶
		cemCfgSpeedPattern_Set(m_nAxis, m_nSpeedMode, m_fVvel1, m_fAcc, m_fDec);
		if((g_nErrCode = cemSxMoveToStart2V(m_nAxis, m_fDistPos, m_fVvel2)) != ceERR_NONE){ 
			//ShowCnSdkError(g_nErrCode);
		}
		cemSxWaitDone(m_nAxis, false);
	}
}

void CSxMotion_2VelDlg::OnBtnStop() 
{
	m_nAxis = m_cmbAxisSel.GetCurSel();
	if((g_nErrCode = cemSxStop(m_nAxis, TRUE, FALSE)) != ceERR_NONE){
		ShowCeSdkError(g_nErrCode);
	}
}

void CSxMotion_2VelDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	KillTimer(0);

	m_nAxis = m_cmbAxisSel.GetCurSel();
	cemSxStop(m_nAxis, FALSE, FALSE);
	ceGnUnload(); // Unload Device
	ceUnloadDll(); // Unload DLL
}

void CSxMotion_2VelDlg::OnchkServoOn() 
{
	m_nAxis = m_cmbAxisSel.GetCurSel();
	int nCheck = ((CButton *)GetDlgItem(IDC_chkServoOn))->GetCheck();
	cemGnServoOn_Set(m_nAxis, nCheck);
	
}

void CSxMotion_2VelDlg::OnBtnResetgraph() 
{
	OnResetPlot();
}
